(function (angular) {
    "use strict";
    angular.module('account.controller', ['account.service', 'global.service'])
        .controller('AccountCtrl', ['$scope', '$state', 'AccountFty', 'GlobalFunFty',
            function ($scope, $state, AccountFty, GlobalFunFty) {
                AccountFty.wechat();    // 微信分享

                $scope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
                    $scope.from = from;
                    GlobalFunFty.detLogin()
                        .then(function (data) { // 一登陆
                            $scope.uuid = GlobalFunFty.getLocal('uuid');

                            $scope.signature = GlobalFunFty.getLocal('signature');

                            AccountFty.getUserInfo({
                                uuid: $scope.uuid,
                                signature: $scope.signature
                            })
                                .then(function (data) {
                                    var userinfo = data.data.data
                                    $scope.userName = userinfo.username;
                                    angular.forEach(userinfo, function (val, key) {
                                        GlobalFunFty.setLocal(key, val);
                                    })
                                }, function (err) {
                                    GlobalFunFty.info(err)
                                    $state.go('login', {
                                        prePage: $scope.from
                                    });
                                })

                            return AccountFty.getInfo({
                                uuid: $scope.uuid,
                                signature: $scope.signature
                            });

                        }, function (err) { // 未登录
                            if (from.name === 'login') {
                                $state.go('tab.home');
                            } else {
                                $state.go('login', {
                                    prePage: $scope.from
                                });
                            }
                            return GlobalFunFty.errFun("您还没有登陆");
                        })
                        .then(function (data) {

                            $scope.userState = AccountFty.getStates(data.data.data);
                        }, function (err) {
                            GlobalFunFty.info(err);
                        });
                });// 监听路由改变成功记住状态

                $scope.listItems = [
                    {
                        name: '采购订单',
                        iconfont: 'img/account/icon-cgdd.png',
                        className: '',
                        goTo: "order({where:'purchase'})"
                    },
                    {
                        name: '供应订单',
                        iconfont: 'img/account/icon-gydd.png',
                        className: '',
                        goTo: "order({where:'provide'})"
                    },
                    {
                        name: '采购消息',
                        iconfont: 'img/account/icon-cgxx.png',
                        className: '',
                        goTo: "message({where:'purchase'})"
                    },
                    {
                        name: '供应消息',
                        iconfont: 'img/account/icon-gyxx.png',
                        className: 'mar-bom10',
                        goTo: "message({where:'supply'})"
                    },
                    {name: '我的收藏', iconfont: 'img/account/icon-mySc.png', className: '', goTo: "collect.msg.supply"},
                    {name: '我的店铺', iconfont: 'img/account/icon-myShop.png', className: '', goTo: "myShop"},
                    {
                        name: '个人认证',
                        iconfont: 'img/account/icon-grrz.png',
                        className: '',
                        goTo: 'authentication({currentChoose:"personal"})'
                    },
                    {
                        name: '企业认证',
                        iconfont: 'img/account/icon-qyrz.png',
                        className: 'mar-bom10',
                        goTo: 'authentication({currentChoose:"enterprise"})'
                    },
                    {name: '意见反馈', iconfont: 'img/account/icon-yjfk.png', className: 'mar-bom10', goTo: 'feedBack'},
                ]; // 页面 list

                $scope.Logout = function () {
                    GlobalFunFty.clearLocal('address',
                        'gender',
                        'phone',
                        'qq',
                        'signature', 'status', 'username', 'uuid', 'wechat', 'password', 'keyWord0', 'keyWord1', 'keyWord2');

                    GlobalFunFty.detLogin(true)
                };// 退出登陆事件

            }]);

})(window.angular);