(function (angular, $) {
    "use strict";
    angular.module('authBegain.controller', ['authBegain.service', 'global.service'])
        .controller('AuthBegainCtrl', ['$scope', 'GlobalFunFty', '$stateParams', 'AuthBegainFty', 'GlobalVariable',
            function ($scope, GlobalFunFty, $stateParams, AuthBegainFty, GlobalVariable) {
                AuthBegainFty.wechat();
                if ($stateParams.currentChoose === "enterprise") {
                    $scope.pageInfo = {
                        addUrl: AuthBegainFty.addEnterAuthenticateApi,
                        currentpage: 'enterprise',
                        showBox: $stateParams.state,
                    };
                    $scope.sublimeParams = {
                        enterpriseName: '',
                        businessType: {
                            niu: '',
                            yang: ''
                        },
                        address: {
                            address: '',
                            street: ''
                        },
                        businessLicensePic: '',
                        phone: '',
                        identityName: '',
                        indetityNumber: '',
                        pictureFront: '',
                        pictureBack: '',
                        handheldPhoto: '',
                    };
                    $scope.imageList = {    // 储存image
                        businessLicensePic: null,
                        pictureFront: null,
                        pictureBack: null,
                        handheldPhoto: null
                    };
                    $scope.name = "企业认证";
                } else if ($stateParams.currentChoose === "personal") {
                    $scope.pageInfo = {
                        addUrl: AuthBegainFty.addUserAuthenticateApi,
                        currentpage: 'personal',
                        showBox: $stateParams.state,
                    };
                    $scope.sublimeParams = {
                        businessType: {
                            niu: '',
                            yang: ''
                        },
                        address: {
                            address: '',
                            street: ''
                        },
                        identityName: '',
                        indetityNumber: '',
                        pictureFront: '',
                        pictureBack: '',
                        handheldPhoto: '',
                    };
                    $scope.imageList = {    // 储存image
                        pictureFront: null,
                        pictureBack: null,
                        handheldPhoto: null
                    };
                    $scope.name = "个人认证";
                }

                $scope.modelShow = true;

                $scope.openModal = function () {
                    $scope.modelShow = false;
                };

                $scope.closeModal = function (e) {
                    $scope.modelShow = true;
                };

                $scope.currentPlaceNum = -1;


                $scope.$on('scroll-finish', function ($event, data) {

                    $event.stopPropagation();

                    $scope.jroll = data;

                    // 取消键盘遮挡  因为有 BUG 未解决
                    // $scope.jroll.fixedinput(150); //使该JRoll对象里的input/textarea在focus时能自动上移到可见位置
                    AuthBegainFty.refreshJroll($scope.jroll);
                }); // jroll 初始化完成事件


                if ($stateParams.state === "fail") {
                    if (!$stateParams.data) {return;}  // 如果没有数据 直接返回

                    $scope.errmsg = ($stateParams.data.auditProfile) || "未知原因"; // 失败数据填充

                    $scope.submitAgain = function (some) {                         // 页面数据填充函数
                        var data = $stateParams.data;
                        if ((data.authenticationStatus === 2 && data.auditStatus === 3) ||
                            ((data.authenticationStatus === 1 && data.auditStatus === 2))     // 这两个状态下 则禁止更改填充数据
                        ) {
                            $scope.some = true;
                        }
                        // 数据填充
                        var newParams = AuthBegainFty.failParams($scope.sublimeParams, $scope.imageList, data, GlobalVariable.IMG_OSS_RULE().authentication);
                        $scope.sublimeParams = newParams.sublimeParams;
                        $scope.imageList = newParams.imageList;

                        // 数据初始化后 显示第一页跟状态更改为第一页
                        $scope.pageInfo.showBox = 'begain';
                        $scope.$emit('changeStutas', 'begain');
                        if($scope.jroll){
                            AuthBegainFty.refreshJroll($scope.jroll);
                        }
                    };
                    // 在 fail 页面 查看参数是否显示 fail 页面
                    if (!$stateParams.isShowFailPage) {
                        $scope.submitAgain();
                    }
                }// 初始化值后 如果在 fail 页面 则需要重新初始化


                // 接受 image 指令传送的数据
                $scope.$on('to-imagelist', function (event, data) {
                    $scope.imageList[data.name] = data;
                    $scope.$apply();
                });

                // img 点击事件
                $scope.showImg = function (event) {
                    event.stopPropagation();
                    if (event.target.nodeName !== "IMG") {
                        GlobalFunFty.showDelImage(event,0, function (Ele, index) {
                            $scope.imageList[Ele.attr('data-name')] = null;
                            $scope.$apply();
                        });
                    }
                };

                // 获取所在地
                GlobalFunFty.getGetInfos({
                    url: AuthBegainFty.getAllGoodsLocusApi,
                })
                    .then(function (data) {
                        $scope.currentPlace = data.data.data;
                    }, function (err) {
                        GlobalFunFty.info(err);
                    })
                    .finally(function () {
                        setTimeout(function () {
                            $(' .searchItim', '#authBegain').accordion({
                                //accordion: true,
                                speed: 100,
                                closedSign: '[+]',
                                openedSign: '[-]'
                            });
                        }, 500);
                    });
                $scope.changePlace = function (city) {
                    $scope.sublimeParams.address.address = city.goodsLocusName;
                    $scope.currentPlaceNum = city.id;
                    $scope.closeModal();
                };
                // 提交
                $scope.sublime = function () {
                    var obj = AuthBegainFty.ValidationData($scope.sublimeParams, $scope.imageList, $stateParams.currentChoose); // 验证数据
                    if (!obj) {return;}
                    GlobalFunFty.showImgUpload(function () {    // 打开上传图片LOGO 层 并上传图片
                        AuthBegainFty.uploadImage($scope.imageList)
                            .then(function (data) {
                                var updataObj = GlobalFunFty.paramsCopy(obj, data);
                                angular.forEach(updataObj, function (val, key) {
                                    if(!val) updataObj[key] = "";
                                })

                                return GlobalFunFty.getPostInfos({// 图片上传完毕 开始上传认证消息
                                    url: $scope.pageInfo.addUrl,
                                    data: updataObj
                                });
                            }, function (err) {
                                GlobalFunFty.info(err);
                            })
                            .then(function (data) {
                                GlobalFunFty.closeAll();// 关闭上传莫泰狂
                                $scope.pageInfo.showBox = 'ing';
                                $scope.$emit('changeStutas', 'ing');
                            }, function (err) {
                                GlobalFunFty.info(err);
                            })
                            .finally(function () {
                                $scope.jroll.scrollTo(0, 0, 0);
                                AuthBegainFty.refreshJroll($scope.jroll);
                            });

                    });


                };
            }]);

})(window.angular, window.$);