(function (angular) {
    "use strict";
    angular.module('authentication.controller', ['authentication.service', 'global.service'])
        .controller('AuthenticationCtrl', ['$scope', '$state', '$stateParams', 'AuthenticationFty', 'GlobalFunFty',
            function ($scope, $state, $stateParams, AuthenticationFty, GlobalFunFty) {

                AuthenticationFty.wechat();
                // 获取参数
                $scope.params = $stateParams.currentChoose;

                if ($scope.params === 'enterprise') {// 企业认证

                    $scope.title = '企业认证';

                    /**
                     * @param 1 个人页面跳转
                     * @param 2 企业页面跳转
                     * @param 3 个人页面是否显示失败 true 则显示 fail 页面
                     * @param 4 企业页面是否显示失败 true 则显示 fail 页面
                     * @param 5 页面填充数据
                     */
                    $scope.setCurrent = function (per, ent, isf, isc, data) {

                        if (ent === 'not') {
                            GlobalFunFty.showEnterpriseIn();
                            return;
                        }

                        $scope.currentState = ent;

                        $state.go('authentication.state', {
                            state: ent,
                            isShowFailPage: isc,
                            data: data
                        });
                    };
                } else if ($scope.params === 'personal') {// 个人认证

                    $scope.title = '个人认证';

                    $scope.setCurrent = function (per, ent, isf, isc, data) {

                        $scope.currentState = per;

                        $state.go('authentication.state', {
                            state: per,
                            isShowFailPage: isf,
                            data: data
                        });
                    };
                }

                $scope.$on('changeStutas', function (event, data) {
                    $scope.currentState = data;
                });// 接受来自子路由当前 state

                AuthenticationFty.getAuthInfo()
                    .then(function (datainfo) {

                        AuthenticationFty.goChildrenPage(datainfo, $scope.setCurrent);// 根据数据 操作子页面变化

                    }, function (err) {
                        GlobalFunFty.msg("您可能未登录，请重新登陆后重试");
                        GlobalFunFty.info(err);
                    });


            }]);

})(window.angular);