(function (angular) {
    "use strict";
    // 引导页功能数据请求模块
    angular.module('changepassworld.service', ['global.service'])
        .factory('ChangepassworldFty', ['GlobalVariable', 'GlobalFunFty', '$q',
            function (GlobalVariable, GlobalFunFty, $q) {
                return {
                    changePasswordApi: GlobalVariable.SERVER_PATH + '/myhome/account/modifyPasswd',

                    changePassword: function (obj) {
                        return GlobalFunFty.getPostInfos({
                            url: this.changePasswordApi,
                            data: obj
                        });
                    },

                    verificationParams: function (obj) {
                        var password = GlobalFunFty.getLocal('password').trim(),
                            deferred = $q.defer();
                        if (obj.oldPassword.trim() === obj.password.trim()) {
                            deferred.reject('新旧密码不能一样');
                        }
                        if (obj.oldPassword.trim() !== password) {
                            deferred.reject('旧密码不正确');
                        } else if (obj.password.trim().length < 6 || obj.password.trim().length > 16) {
                            deferred.reject('新密码应该在6-16位之间');
                        } else if (obj.password.trim() !== obj.confirmPwd.trim()) {
                            deferred.reject('两次输入的密码不一致');
                        }
                        this.changePassword(obj)
                            .then(function (data) {
                                deferred.resolve(data);
                            }, function (err) {
                                deferred.reject(err);
                            });
                        return deferred.promise;
                    },

                    wechat: function () {
                        GlobalFunFty.wxNoShare();
                    }
                };
            }]);

})(window.angular);