(function (angular) {
    "use strict";
    angular.module('changeph.controller', ['changeph.service', 'global.service'])
        .controller('ChangephCtrl', ['$scope', '$state', '$window', 'GlobalVariable', '$stateParams', 'GlobalFunFty', 'ChangephFty', function ($scope,$state, $window, GlobalVariable, $stateParams, GlobalFunFty, ChangephFty) {

            $scope.current = $stateParams.current;

            GlobalFunFty.detLogin(true);

            if ($stateParams.current === 'first') {    // 第一屏
                $scope.title = "验证旧手机";
                $scope.headerNext = "下一步";
                $scope.sendparmes = {
                    uuid: GlobalFunFty.getLocal('uuid'),
                    signature: GlobalFunFty.getLocal('signature'),
                    phone: GlobalFunFty.getLocal('phone'),               // 手机号
                    phoneVerifCode: '',     // 验证码
                    phoneErr: '',            // 手机号是否合法
                    codeErr: false,            // 验证码是否合法
                    codeErrMsg: '',         // 验证码信息
                    clidked: '',            // 是否点击了发送验证码
                    sendtime: false,        // 验证码按钮是否可以点击状态
                    count: GlobalVariable.VERIFCODE_TIME,   // 验证码点击后时间
                    time: '发送验证码',
                    sendCode: function () {// 点击发送验证码
                        if($scope.sendparmes.sendtime)  {return;}
                        ChangephFty.sendPhondCode($scope.sendparmes.phone)
                            .then(function (data) {
                                $scope.sendparmes.codeErr = true;
                                $scope.sendparmes.codeErrMsg = '';
                            },function (err) {
                                $scope.sendparmes.codeErr = false;
                                $scope.sendparmes.codeErrMsg = err;
                                GlobalFunFty.info(err);
                            })
                            .finally(function () {
                                var timer = $window.setInterval(function () {
                                    $scope.sendparmes.time = '倒计时' + $scope.sendparmes.count + 's';
                                    $scope.sendparmes.count--;
                                    $scope.sendparmes.sendtime = true;
                                    $scope.$apply();
                                    if($scope.sendparmes.count < 0 ){
                                        $window.clearInterval(timer);
                                        $scope.sendparmes.time = '发送验证码';
                                        $scope.sendparmes.sendtime = false;
                                        $scope.sendparmes.count = 120;
                                        $scope.$apply();
                                    }
                                }, 1000);

                            });
                    },
                    next: function () {
                        if($scope.sendparmes.codeErr){
                            if(!$scope.sendparmes.phoneVerifCode){
                                $scope.sendparmes.codeErrMsg = "请填写正确格式的验证码";
                                return;
                            }
                            ChangephFty.validateCode({
                                phone: $scope.sendparmes.phone,
                                phoneVerifCode: $scope.sendparmes.phoneVerifCode
                            })
                                .then(function (data) {
                                    $state.go("changephone.current", {
                                        current:'next'
                                    });
                                }, function (err) {
                                    $scope.sendparmes.codeErrMsg = err;
                                    GlobalFunFty.info(err);
                                });


                        }else {
                            $scope.sendparmes.codeErr = false;
                            $scope.sendparmes.codeErrMsg = "请先发送验证码";
                        }
                    }
                };
            } else {
                // 第二屏
                $scope.title = "验证新手机";
                $scope.headerNext = "完成";
                $scope.$watch('sendparmes.phone', function (newValue, oldValue) {
                    if (newValue === oldValue) {return;}
                    if($scope.sendparmes.regPhone.test($scope.sendparmes.phone)){
                        ChangephFty.usablePhone($scope.sendparmes.phone, function (data) {
                            $scope.sendparmes.phoneErr = '';
                            $scope.sendparmes.sendtime = true;
                            GlobalFunFty.info(data);
                        }, function (err) {
                            GlobalFunFty.info(err);
                            $scope.sendparmes.phoneErr = err;
                        });
                    }else {
                        $scope.sendparmes.phoneErr = '手机号码格式不正确';
                    }
                });
                $scope.sendparmes = {
                    regPhone:GlobalVariable.TEST_PHONE_REGXP,
                    uuid: GlobalFunFty.getLocal('uuid'),
                    signature: GlobalFunFty.getLocal('signature'),
                    phone: '',               // 手机号
                    phoneVerifCode: '',     // 验证码
                    phoneErr: '',            // 手机号是否合法
                    codeErr: false,            // 验证码是否合法
                    codeErrMsg: '',         // 验证码信息
                    clidked: '',            // 是否点击了发送验证码
                    sendtime: false,        // 验证码按钮是否可以点击状态
                    count: 120,             // 验证码点击后时间
                    time: '发送验证码',
                    sendCode: function () {// 点击发送验证码
                        if(!$scope.sendparmes.sendtime) {
                            return;
                        }
                        if(!$scope.sendparmes.regPhone.test($scope.sendparmes.phone)){
                            $scope.sendparmes.phoneErr = "手机号码格式不正确";
                            return;
                        }
                        ChangephFty.sendPhondCode($scope.sendparmes.phone)
                            .then(function (data) {
                                $scope.sendparmes.codeErr = true;
                                $scope.sendparmes.codeErrMsg = '';
                            },function (err) {
                                $scope.sendparmes.codeErr = false;
                                $scope.sendparmes.codeErrMsg = err;
                                GlobalFunFty.info(err);
                            })
                            .finally(function () {
                                $scope.sendparmes.sendtime = false;
                                var timer = $window.setInterval(function () {
                                    $scope.sendparmes.time = '倒计时' + $scope.sendparmes.count + 's';
                                    $scope.sendparmes.count--;
                                    $scope.sendparmes.sendtime = false;
                                    $scope.$apply();
                                    if($scope.sendparmes.count < 0 ){
                                        $window.clearInterval(timer);
                                        $scope.sendparmes.time = '发送验证码';
                                        $scope.sendparmes.sendtime = true;
                                        $scope.sendparmes.count = 120;
                                        $scope.$apply();
                                    }
                                }, 1000);

                            });
                    },
                    next: function () {
                        if(!$scope.sendparmes.regPhone.test($scope.sendparmes.phone)){
                            $scope.sendparmes.phoneErr = "手机号码格式不正确";
                            return;
                        }
                        if(!$scope.sendparmes.phoneVerifCode){
                            $scope.sendparmes.codeErrMsg = "请输入验证码";
                            return;
                        }
                        if($scope.sendparmes.codeErr){
                            ChangephFty.changePhone({
                                phone: $scope.sendparmes.phone,
                                phoneVerifCode: $scope.sendparmes.phoneVerifCode
                            })
                                .then(function (data) {
                                    GlobalFunFty.setLocal('phone', $scope.sendparmes.phone);
                                    $state.go('setting');
                                }, function (err) {
                                    $scope.sendparmes.phoneErr = err;
                                    GlobalFunFty.info(err);
                                });


                        }else {
                            $scope.sendparmes.codeErr = false;
                            $scope.sendparmes.codeErrMsg = "请先发送验证码";
                        }
                    }
                };
            }

            $scope.$on('next-click', function ($event) {
                $scope.sendparmes.next();
            });
        }]);

})(window.angular);