(function (angular) {
    "use strict";
    // 引导页功能数据请求模块
    angular.module('changeph.service', ['global.service'])
        .factory('ChangephFty', ['GlobalVariable', 'GlobalFunFty',function(GlobalVariable, GlobalFunFty) {
            return {
                PhoneCodeApi: GlobalVariable.SERVER_PATH + '/phone/sendPhoneVerifCode',        // 发送验证码
                rightCodeApi: GlobalVariable.SERVER_PATH + '/myhome/account/verifyPhone',      // 验证码是否正确
                modifyPhoneApi: GlobalVariable.SERVER_PATH + '/myhome/account/modifyPhone',      // 修改手机号码
                validatePhoneApi: GlobalVariable.SERVER_PATH + "/register/validatePhone",      // 手机号是否可用
                sendPhondCode: function (phone) {
                    return GlobalFunFty.getGetInfos({
                        url: this.PhoneCodeApi,
                        data: GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), {phone:phone})
                    });
                },
                validateCode: function (obj) {
                    return GlobalFunFty.getGetInfos({
                        url: this.rightCodeApi,
                        data: GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), obj)
                    });
                },
                usablePhone: function (phone, success, errfn) {
                    GlobalFunFty.getGetInfos({
                        url: this.validatePhoneApi,
                        data: GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), {phone:phone})
                    })
                        .then(function (data) {
                            success(data)
                        }, function (err) {
                            errfn(err)
                        });
                },
                changePhone: function (obj) {
                    return GlobalFunFty.getGetInfos({
                        url: this.modifyPhoneApi,
                        data: GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), obj)
                    });
                }
            };
        }]);

})(window.angular);