(function (angular) {
    "use strict";
    angular.module('collect.controller', ['collect.service'])
        .controller('CollectCtrl', ['$scope', '$state', 'CollectFty', function ($scope, $state, CollectFty) {

            CollectFty.wechat();
            // 由于 ui-sref-active 的多路由嵌套问题 所以需要手动给路由 active 状态
            $scope.currentPage = $state.current.name.indexOf("collect.msg") > -1;

            // 如果 路由发生变化 就初始化页面默认数据
            $scope.$on('$locationChangeStart', function ($event) {
                console.log();
                $scope.currentPage = $state.current.name.split('.')[0] + '.' + $state.current.name.split('.')[1];
                $scope.deleted = false;
                $scope.text = '';
            });
            $scope.text = '';
            $scope.deleted = false;

            // 点击删除垃圾桶出发删除事件
            $scope.del = function () {
                $scope.deleted = !$scope.deleted;
                if ($scope.deleted) {
                    $scope.text = '完成';
                } else {
                    $scope.text = '';
                }
                // 向子控制器发送事件 点击了删除按钮
                $scope.$broadcast('del-click', true);
            };
            $scope.$on('close', function (event) {
                $scope.deleted = !$scope.deleted;
                $scope.text = '';
            })
        }]);

})(window.angular);
