(function (angular) {
    "use strict";
// 引导页功能数据请求模块
    angular.module('collect.service', ['global.service'])
        .factory('CollectFty', ['GlobalFunFty', 'GlobalVariable', '$state', function (GlobalFunFty, GlobalVariable, $state) {
            return {
                getProvideApi: GlobalVariable.SERVER_PATH + '/myhome/collection/getProvideByIdDetails', // 获取收藏供应消息
                delProvideApi: GlobalVariable.SERVER_PATH + '/myhome/collection/deleteProvide', // 删除收藏供应消息
                getPurchaseApi: GlobalVariable.SERVER_PATH + '/myhome/collection/getPurchaseByIdDetails', // 获取收藏采购消息
                delPurchaseApi: GlobalVariable.SERVER_PATH + '/myhome/collection/deletePurchase', // 删除收藏采购消息
                getGoodsApi: GlobalVariable.SERVER_PATH + '/myhome/collection/getGoodsByIdDetails', // 获取收藏商品消息
                delGoodsApi: GlobalVariable.SERVER_PATH + '/myhome/collection/deleteGoods', // 删除收藏商品消息
                getShopApi: GlobalVariable.SERVER_PATH + '/myhome/collection/getShopByIdDetails', // 获取收藏店铺消息
                delShopApi: GlobalVariable.SERVER_PATH + '/myhome/collection/deleteShop', // 删除收藏店铺消息
                getUrlInfo: function () {
                    var obj = [];
                    if($state.current.name ==='collect.msg.supply'){
                        obj.getUrl = this.getProvideApi;
                        obj.delUrl = this.delProvideApi;
                    }else if($state.current.name ==='collect.goods') {
                        obj.getUrl = this.getGoodsApi;
                        obj.delUrl = this.delGoodsApi;
                    }else if($state.current.name ==='collect.msg.procure') {
                        obj.getUrl = this.getPurchaseApi;
                        obj.delUrl = this.delPurchaseApi;
                    }else if($state.current.name ==='collect.shop') {
                        obj.getUrl = this.getShopApi;
                        obj.delUrl = this.delShopApi;
                    }
                    return obj;
                },
                getPageInfo: function (obj) {
                    return GlobalFunFty.getGetInfos({
                        url: this.getUrlInfo().getUrl,
                        data: GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), obj)
                    });
                },
                delPageInfo: function (obj) {
                    return GlobalFunFty.getGetInfos({
                        url:this.getUrlInfo().delUrl,
                        data: GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), obj)
                    });
                },
                wechat: function () {
                    GlobalFunFty.wxNoShare();
                }
            };
        }]);
})(window.angular);

