/**
 * @ProjectName: www
 * @FileName: search_controller.js
 * @Author: wenpeng.young@gmail.com
 * @date: 2017-08-16 18:09
 */
'use strict';
(function (angular) {
    "use strict";
    angular.module('components.search', [])
        .controller('SearchCtrl', ['$scope', '$stateParams', '$window', 'GlobalFunFty', '$state','GlobalVariable', function ($scope, $stateParams, $window, GlobalFunFty, $state, GlobalVariable) {
            $('#home-animate').removeClass('hide');
            $scope.formData = {
                where: 'tab.supply',
                keyword: '',
                metype: false
            };
            $scope.promptList = [];
            $scope.changePrompt =function (keywprd) {
                if(!(keywprd = keywprd.trim())){$scope.promptList = []; return};
                GlobalFunFty.getGetInfos({
                    url: GlobalVariable.SERVER_PATH + '/category/getMeatCategoryInfos',
                    data: {
                        keyWord: keywprd
                    }
                })
                    .then(function (ret) {
                        var data = (ret.data.data.length>10?ret.data.data.length=10:true) && ret.data.data
                        $scope.promptList = data;
                        console.log(data);
                    }, function (err) {
                        GlobalFunFty.msg(err)
                    })
            };

            $scope.$watch('formData.metype', function (newVal) {
                try {
                    $scope.history = JSON.parse(GlobalFunFty.getLocal('history' + Number($scope.formData.metype)) || '[]');
                }catch (err) {
                    GlobalFunFty.clearLocal('history' + Number($scope.formData.metype))
                    $scope.history = [];
                    GlobalFunFty.setLocal('history' + Number($scope.formData.metype), JSON.stringify($scope.history))
                }

            })

            $scope.removeHistory = function () {
                GlobalFunFty.clearLocal('history' + Number($scope.formData.metype))
                $scope.history = [];
            }

            $scope.search = function (keyword) {
                keyword = keyword || $scope.formData.keyword;
                if(!keyword) return;
                $scope.history.unshift(keyword)
                if($scope.history.length > 10)$scope.history.length = 10;
                GlobalFunFty.setLocal('history' + Number($scope.formData.metype), JSON.stringify($scope.history))
                $state.go($scope.formData.where, {
                    keyWord: keyword,
                    name: keyword,
                    meatType: Number($scope.formData.metype)
                })
            }

        }]);

}(window.angular));