/**
 * @ProjectName: www
 * @FileName: scrollBox.js
 * @Author: wenpeng.young@gmail.com
 * @date: 2017-07-10 14:28
 */
'use strict';

(function (angular) {
    angular.module('components.scrollBox', [])
        .directive('scrollBox', ['$window', function ($window) {
            return {
                restrict: 'EA',
                link: function (scope, element, attrs) {
                    var speedRate =attrs.speed && Number(attrs.speed) || 5,  // 速率
                        startY = 0, // 手指起始点 Y 坐标
                        distanceY = 0,  // 手指移动的距离
                        flag = true,    // 是否可以滑动
                        currentY = 0;    // 是否可以滑动
                    var removeTransition = function (ele) {
                            ele.style.transition = 'none';
                        },
                        setTransition = function (ele, y) {
                            // currentY = y;
                            ele.style.transform = 'translateY(' + y + 'px)';
                        },
                        addTransition = function (ele, time) {
                            ele.style.transition = "all " + time;
                        },
                        container = element.children('div');

                    // 初始化 样式
                    element.css({
                        position: 'absolute',
                        top: (attrs.top + 'px') || 0 ,
                        left: attrs.left || 0,
                        bottom: attrs.footer || 0,
                        right: attrs.right || 0,
                        'overflow-x': 'hidden',
                        'overflow-y': 'auto',
                    })
                    container.css({
                        width: '100%',
                        'min-height': '100%'
                    })
                    // 初始化数据
                    scope.downText = "下拉刷新"

                    element.on('scroll', function (e) {
                        var scrollTop = e.target.scrollTop;
                        scope.rememberScrollTop && scope.rememberScrollTop(scrollTop);
                        flag = false;
                        if(scrollTop <= 0 || scrollTop >= container[0].offsetHeight - element[0].offsetHeight) {
                            flag = true;
                        }
                        setTransition(container[0], 0);
                    })
                    scope.toScrollTop = function (top) {
                        element[0].scrollTop = top;
                    }
                    container.on('touchstart', function (e) {
                        if(!flag) return;
                        startY = e.touches[0].pageY;    // 记录手指当前 Y 距离
                    })

                    container.on('touchmove', function (e) {
                        if(!flag) return;
                        removeTransition(container[0]);  // 每次移动 都清空 truansition
                        console.log(distanceY);
                        setTransition(container[0], distanceY);
                        distanceY = Math.ceil((e.touches[0].pageY - startY + currentY) / speedRate);  // 需要移动的距离 = 总距离 / 速率
                    })

                    container.on('touchend', function (e) {
                        if(!flag) return;
                        addTransition(container[0], '0.2s');
                        setTransition(container[0], 0);
                    })

                    container[0].addEventListener('transitionend', function () {

                    })
                }
            }
        }])
})(angular)
