(function (angular) {
    "use strict";
    angular.module('components.scrollContent', [])
        .directive('scrollContent', ['$window', 'GlobalFunFty', function ($window, GlobalFunFty) {
            return {
                restrict: 'A',
                link: function(scope,element,attr){
                    scope.parentEle = element.parent();
                    scope.jrollInit = new $window.JRoll(scope.parentEle[0], {
                        scrollBarY: !!attr.scrollBarY,
                        scrollBarFade: !!attr.scrollBarFade
                    });
                    scope.$emit('scroll-finish', scope.jrollInit);
                    // 每次 del 点击 都给盒子一个 footer
                    scope.$on('del-click', function () {
                        scope.parentEle.hasClass('has-footer')?
                            scope.parentEle.removeClass('has-footer'):scope.parentEle.addClass('has-footer');
                        GlobalFunFty.JrollRefresh(scope.jrollInit);
                    });
                }
            };
        }])
        .directive('repeatFinish', [function () {
            return {
                restrict: 'A',
                link: function(scope,element,attr){
                    if(scope.$last === true){
                        scope.$eval(attr.repeatFinish);
                        //向父控制器传递事件
                        //scope.$emit('to-parent');
                        //向子控制器传递事件
                        //scope.$broadcast('to-child');
                    }
                }
            };

        }]);


})(window.angular);