(function (angular) {
    "use strict";
    angular.module('components.timerftr', [])
        .filter('selfTime', [function () {
            return function (strTime, params1) {
                if (!strTime) {
                    return;
                }
                strTime = strTime.replace(/-/g, "/");
                var currentTime = new Date(),
                    oldTime = new Date(strTime),
                    showYear, showMonth, showDay, showHour, showMinute, showTime;

                showYear = currentTime.getFullYear() - oldTime.getFullYear();
                showMonth = currentTime.getMonth() - oldTime.getMonth();
                showDay = currentTime.getDate() - oldTime.getDate();
                showHour = currentTime.getHours() - oldTime.getHours();
                showMinute = currentTime.getMinutes() - oldTime.getMinutes();

                if (showYear === 0) { // 同一年内
                    if (showMonth === 0) { // 同月内
                        if (showDay === 0) {  // 同天内
                            if (showHour === 0) { // 同一小时内
                                if (showMinute <= 10) {   // 十分钟内 就显示 刚刚
                                    showTime = "刚刚"
                                } else {     // 十分钟外就显示 几分钟前
                                    showTime = showMinute + "分钟前"
                                }
                            } else if (showHour > 0 && showHour <= 1 && (currentTime.getMinutes() + (60 - oldTime.getMinutes())) <= 60) {  // 不同一小时 就判断分钟是否大于 60 分钟
                                showTime = (currentTime.getMinutes() + (60 - oldTime.getMinutes())) + '分钟前';
                            } else {
                                showTime = showHour + "小时前"
                            }
                        } else if (showDay > 0 && showDay <= 1 && (currentTime.getHours() + (24 - oldTime.getHours())) <= 24) {  // 不同天就判断时间是否大于 24 小时
                            showTime = (currentTime.getHours() + (24 - oldTime.getHours())) + '小时前';
                        } else {
                            showTime = showDay + "天前"
                        }
                    } else { // 月份不同 就显示几月几号
                        showTime = (oldTime.getMonth() + 1) + "月" + oldTime.getDate() + "日"
                    }

                } else { // 年不同 就显示全部
                    showTime = oldTime.getFullYear() + "年" + (oldTime.getMonth() + 1) + "月" + oldTime.getDate() + "日"
                }
                return showTime || strTime.split(" ")[0];
            };
        }]);
})(window.angular);