(function (angular) {
    "use strict";
    angular.module('components.uploadImage', [])
        .directive('uploadImage', ['$timeout', '$window', 'GlobalFunFty',
            function ($timeout, $window, GlobalFunFty) {
                return {
                    scope: {
                        onlyone: '@',
                        name: '@'
                    },
                    link: function (scope, element, attr) {
                        scope.parentElement = element.parent().parent();
                        element.on('change', function () {
                            scope.data.changeInput = true;
                            scope.data.name = scope.name;
                            var files, parent = scope.parentElement;
                            if (!this.files.length) {
                                return;
                            }
                            files = Array.prototype.slice.call(this.files);
                            if (files.length + scope.data.imgList.length > 5) {
                                GlobalFunFty.msg("最多上传五张图片");
                                return;
                            }
                            if (files.length + scope.data.imgList.length === 5) {
                                parent.addClass('hide');
                            } else {
                                parent.removeClass('hide');
                            }
                            GlobalFunFty.msg('正在压缩图片');
                            files.forEach(function (file) {
                                $window.lrz(file, {
                                    quality: 0.7,
                                    fieldName: 'imageFile',
                                    width: 880
                                })
                                    .then(function (rst) {
                                        if (scope.onlyone) {    // 如果只上传一张的话 直接把数据发送出去
                                            scope.$emit('to-imagelist', {
                                                changeInput: true,
                                                imageList: rst,
                                                name: scope.name
                                            });
                                        } else {
                                            scope.data.imgList.push(rst); // 如果多张的话 就把数据放到数组中 发送出去
                                            scope.$emit('to-imagelist', scope.data);
                                        }
                                    })
                                    .catch(function (err) {
                                        // 处理失败会执行
                                        GlobalFunFty.info(err);
                                        GlobalFunFty.msg('压缩图片失败，请稍后重试');
                                    })
                                    .always(function () {
                                        // 不管是成功失败，都会执行

                                    });
                            });
                        });
                    },
                    controller: ['$scope', function ($scope) {
                        $scope.data = {
                            changeInput: false,
                            imgList: [],

                        };
                        $scope.$on('delete-image', function (event) {
                            var dataImageList = event.targetScope.mySelef.imageList;
                            $scope.data.imgList = dataImageList;
                            if ($scope.data.imgList.length < 5) {
                                $scope.parentElement.removeClass('hide');
                            }
                            $scope.$apply();
                        });
                    }],
                };

            }]);
})(window.angular);