(function (angular) {
    "use strict";
    /**
     * Created by whw on 2017/3/21.
     */
    angular.module('components.mySwiper', ['global.service'])
        .directive('mySwiper', [function () {
            return {
                restrict: 'E',
                templateUrl: 'models/components/swiper/swiper.tmpl.html',
                controllerAs: 'MySwiperController',
                scope: {
                    name: '@'
                },
                replace: true,
                link: function (scope, element, attrs) {
                },
                controller: ['$scope', '$window', 'GlobalVariable', 'GlobalFunFty', '$timeout', '$state',
                    function ($scope, $window, GlobalVariable, GlobalFunFty, $timeout, $state) {
                        if (!$scope.name) {
                            return;
                        }
                        $scope.url = $scope.name === 'home' ? '/home/getHomeBannerInfos' : '';
                        $scope.showSearch = function (a) {
                            var str;

                            if($scope.name === 'home') {
                                str = 'tab.home.search'
                            }else if($scope.name === 'supermarket'){
                                str = 'supermarket.search'
                            }
                            $state.go(str, {
                                search:true
                            });
                        };
                        // 区分首页跟电商 开始赋值

                        if($state.current.name == 'tab.home'){
                            $scope.images = [
                                {id:null, imageUrl:'img/banner/banner_1.png'},
                                {id:null, imageUrl:'img/banner/banner_2.png'},
                                {id:null, imageUrl:'img/banner/banner_3.png'},
                                {id:null, imageUrl:'img/banner/banner_4.png'},
                            ];
                            $scope.goshop = false;
                        }else if($state.current.name === 'supermarket'){
                            $scope.goshop = true;
                            $scope.images = [
                                {id:'2963a906802748dd97d8c8aaf12557d5', imageUrl:'img/banner/3.png'},
                                {id:'6b6cfca1f49e47d2a7aa5d20f2811f14', imageUrl:'img/banner/5.png'},
                                {id:'1242e49c34d043aaaf1324a74b1fb215', imageUrl:'img/banner/4.png'},
                                {id:'535e9af3e9b04691883f572c6c364736', imageUrl:'img/banner/1.png'},
                                {id:'1f985ac84858483a87f03bfbc34697f8', imageUrl:'img/banner/2.png'},
                            ];
                        }

                        $scope.repeatFinish = function () {
                            $timeout(function () {
                                $scope.swiper = new $window.Swiper('#swiper-container', {
                                    pagination: '.swiper-pagination',
                                    lazyLoading: true,
                                    paginationClickable: true,
                                    autoplay: 5000,
                                    loop: true,
                                    observeParents: true,
                                    observer: true,
                                });
                            }, 500);

                        };

                    }]
            };
        }]);

})(window.angular);