(function (angular) {
    "use strict";
    angular.module('delDet.controller', ['delDet.service', 'global.service'])
        .controller('DelDetCtrl', ['$scope', 'DelFty', 'GlobalFunFty', '$stateParams', '$state', '$window', 'GlobalVariable',
            function ($scope, DelFty, GlobalFunFty, $stateParams, $state, $window, GlobalVariable) {
                // 根据 way 参数不同 来隐藏页面
                if ($stateParams.way === 'supply') {
                    $scope.pageInfo = {
                        title: "供应",
                        supply: true,
                        purchase: false,
                    };
                    // 商品信息 & 店铺信息
                    DelFty.getGoodsShopInfo(function (data) {

                        DelFty.wechat({
                            title: '出售-' + (data.data.data.meatCategory[0] || "暂无数据") + '，找牛网清真牛羊肉交易平台',
                            desc: data.data.data.provideDesc,
                            imgUrl: data.data.data.imageList[0] || ''
                        }); // 微信分享

                        $scope.wechatMsg = {
                            title: '出售-' + (data.data.data.meatCategory[0] || "暂无数据") + '，找牛网清真牛羊肉交易平台',
                            description: data.data.data.provideDesc,
                            thumb: 'widget://image/wechat_share/app_icon.png',
                            contentUrl: 'http://m.zhaoniuw.com/#/deliveryDetails/supply/'+$stateParams.id
                        }

                        data.data.data.imageList[0] = data.data.data.imageList[0] || 'img/defaultImg.png';
                        $scope.allShowMsg = data.data.data;
                    }, function (data) {
                        $scope.shop = data.data.data;
                        $scope.uuid = $scope.shop.userId;
                    }, function () {
                        // 并初始化 jroll 对象
                        GlobalFunFty.JrollRefresh($scope.jroll);
                    });

                } else if ($stateParams.way === 'purchase') {
                    $scope.pageInfo = {
                        title: "采购",
                        supply: false,
                        purchase: true,
                    };
                    // 商品信息
                    DelFty.getGoodsInfo('purchaseInfoId')
                        .then(function (data) {
                            DelFty.wechat({
                                title: '求购-' + (data.data.data.meatCategory[0] || "暂无数据") + '，找牛网清真牛羊肉交易平台',
                                desc: data.data.data.purchaseDesc
                            }); // 微信分享

                            $scope.wechatMsg = {
                                title: '求购-' + (data.data.data.meatCategory[0] || "暂无数据") + '，找牛网清真牛羊肉交易平台',
                                description: data.data.data.purchaseDesc,
                                thumb: 'widget://image/wechat_share/app_icon.png',
                                contentUrl: 'http://m.zhaoniuw.com/#/deliveryDetails/purchase/'+$stateParams.id
                            }
                            $scope.allShowMsg = data.data.data;
                            $scope.allShowMsg.content = '';
                        }, function (err) {
                            $state.go('error');
                            GlobalFunFty.info(err);
                            // 店铺信息
                        }).finally(function () {
                        // 并初始化 jroll 对象
                        GlobalFunFty.JrollRefresh($scope.jroll);
                    });
                }

                $scope.jroll = null;
                // 这是 jroll 初始化完成事件  接受 scroll-content 事件
                $scope.$on('scroll-finish', function ($event, data) {
                    $event.stopPropagation();
                    $scope.jroll = data;
                    $scope.jroll.on("scrollEnd", function () {
                        if (this.y === this.maxScrollY) {
                            GlobalFunFty.JrollRefresh($scope.jroll);
                        }
                    });
                    $scope.jroll.on("refresh", function () {

                        $scope.jroll.JrollV =  new $window.JRollViewer('#img-container', {
                            hidden: true,
                            success: function (me, index) {
                                $state.go('deliveryDetails.image', {
                                    number: index,
                                    imagebox: me
                                })
                            }
                        });

                    });// 图片查看集
                    $scope.jroll.fixedinput(120);
                });


                // 分享点击模块   ---------------------------------------------------------------
                $scope.showShare = function () {
                    GlobalFunFty.showShare(function () {
                        // 取消事件
                        $('.share-footer').on('click', function () {
                            GlobalFunFty.closeAll();
                        })
                        // 分享事件
                        $('.share-body').on('click', 'div', function () {
                            if($(this).index()){    // 分享到朋友圈
                                GlobalFunFty.shareFriend($scope.wechatMsg)
                            }else { // 分享到朋友
                                GlobalFunFty.shareFriends($scope.wechatMsg)
                            }
                        })
                    });
                };
                // 收藏模块点击 ----------------------------------------------------------------
                $scope.addCollect = function () {
                    DelFty.addCollect($scope.allShowMsg.isCollection, $scope.shop)
                        .then(function (data) {
                            GlobalFunFty.msg(data.data.message);
                            $scope.allShowMsg.isCollection = !$scope.allShowMsg.isCollection;
                        }, function (err) {
                            if(err !=="不能收藏自己的消息"){
                                GlobalFunFty.msg("收藏失败");
                                return;
                            }
                            GlobalFunFty.msg(err);
                            GlobalFunFty.info(err);
                        });

                };
                // 委托洽谈、供应 功能模块--------------------------------------------------------------
                $scope.addProvide = function () {
                    if ($scope.allShowMsg.status === 3) {return;}    // 如果已经洽谈 return
                    if(!GlobalFunFty.getUserInfo()){
                        GlobalFunFty.detLogin(true);
                        return;
                    }
                    if ($stateParams.way === 'purchase') {
                        if (!$scope.allShowMsg.content) {
                            GlobalFunFty.msg("（必填项）供应商信息没有输入");
                            return;
                        }
                    }
                    DelFty.addProvide($scope.allShowMsg.content)
                        .then(function (data) {
                            GlobalFunFty.showAddProvide($scope.pageInfo.title=='供应'?"采购":"供应", function () {
                                $scope.allShowMsg.status = 3;
                            });
                        }, function (err) {
                            GlobalFunFty.msg(err);
                            GlobalFunFty.info(err);
                        });
                };

                // 图片 OSS
                $scope.oss_goods = GlobalVariable.IMG_OSS_RULE().deliveryDetails
            }]);

})(window.angular);
