(function (angular) {
    "use strict";
    // 引导页功能数据请求模块
    angular.module('delDet.service', ['global.service'])
        .factory('DelFty', ['GlobalVariable', '$stateParams', 'GlobalFunFty', '$state', function (GlobalVariable, $stateParams, GlobalFunFty, $state) {
            return {
                getDetailsApi: GlobalVariable.SERVER_PATH + "/home/getProvideInfoDetail",     // 获取供应详情信息
                getCollectApi: GlobalVariable.SERVER_PATH + "/myhome/collection/provideAndgoods",    // 收藏商品或店铺商品消息
                delProvideApi: GlobalVariable.SERVER_PATH + "/myhome/collection/deleteProvide",    // 删除收藏商品
                delgoodApi: GlobalVariable.SERVER_PATH + "/myhome/collection/deleteGoods",    // 删除收藏店铺商品
                getUserApi: GlobalVariable.SERVER_PATH + '/shop/getUserShop',   // 获取用户店铺信息
                addProvideDetailsApi: GlobalVariable.SERVER_PATH + '/order/add/withProvide',   // 委托洽谈
                getPurchaseDetailsApi: GlobalVariable.SERVER_PATH + '/home/getPurchaseInfoDetail', // 获取采购消息信息
                addPurchaseApi: GlobalVariable.SERVER_PATH + '/order/add/withPurchase', // 供应
                delPurchaseApi: GlobalVariable.SERVER_PATH + '/myhome/collection/deletePurchase', // 删除收藏采购消息
                getPurchaseApi: GlobalVariable.SERVER_PATH + '/myhome/collection/purchase', // 收藏采购消息
                getGoodsInfo: function (paramsNams) {
                    var obj = {};
                    obj[paramsNams] = $stateParams.id;

                    return GlobalFunFty.getGetInfos({
                        url: paramsNams === 'provideInfoId' ? this.getDetailsApi : this.getPurchaseDetailsApi,
                        data: GlobalFunFty.paramsCopy(obj, GlobalFunFty.getUserInfo())
                    });
                },
                getGoodsShopInfo: function (goods, shop, finall) {
                    var _this = this;
                    this.getGoodsInfo('provideInfoId')
                        .then(function (data) {
                            goods(data);
                            return GlobalFunFty.getGetInfos({
                                url: _this.getUserApi,
                                data: {uuid: data.data.data.userId}
                            });
                        }, function (err) {
                            $state.go('error');
                            return GlobalFunFty.errFun(err);
                        })
                        .then(function (data) {
                            shop(data);
                        }, function (err) {
                            GlobalFunFty.info(err);
                        })
                        .finally(function () {
                            finall();
                        });
                },
                addCollect: function (isCollection, shop) {
                    var _this = this;
                    return GlobalFunFty.detLogin(true, function (obj) {
                        if ($stateParams.way === 'supply') {
                            obj.provideId = $stateParams.id;
                            obj.url = _this.getCollectApi;// 默认添加收藏
                            if (isCollection) {
                                obj['ids[]'] = $stateParams.id;
                                obj.url = shop ? _this.delgoodApi : _this.delProvideApi;// 取消收藏
                            }
                        } else if ($stateParams.way === 'purchase') {
                            obj.purchaseId = $stateParams.id;
                            obj.url = _this.getPurchaseApi;// 默认添加收藏
                            if (isCollection) {
                                obj['ids[]'] = $stateParams.id;
                                obj.url = _this.delPurchaseApi;// 取消收藏
                            }
                        }

                        return GlobalFunFty.getPostInfos({
                            url: obj.url,
                            data: obj
                        });
                    });
                },
                addProvide: function (content) {
                    var _this = this;
                    return GlobalFunFty.detLogin(true, function (obj) {
                        var url;
                        if ($stateParams.way === 'purchase') {
                            url = _this.addPurchaseApi;
                            obj.purchaseInfoId = $stateParams.id;
                            obj.content = content;
                        } else if ($stateParams.way === 'supply') {
                            url = _this.addProvideDetailsApi;
                            obj.provideInfoId = $stateParams.id;
                        }
                        return GlobalFunFty.getGetInfos({
                            url: url,
                            data: obj
                        });
                    });
                },
                wechat: function (obj) {
                    GlobalFunFty.wxShare(obj);
                }
            };
        }]);

})(window.angular);