(function (angular) {
    "use strict";
    angular.module('feedBack.controller', ['feedBack.service', 'global.service'])
        .controller('FeedBackCtrl', ['$scope', 'FeedBackFty', 'GlobalFunFty', '$state', '$window',
            function ($scope, FeedBackFty, GlobalFunFty, $state, $window) {

                FeedBackFty.wechat();

                $scope.params = {
                    phone: $window.Number(GlobalFunFty.getLocal('phone')),
                    suggestion: '',
                    browser: '移动端',
                    username: GlobalFunFty.getLocal('username'),
                    uuid: GlobalFunFty.getLocal('uuid'),
                    signature: GlobalFunFty.getLocal('signature'),
                };


                $scope.suBmit = function () {
                    if (!$scope.params.suggestion) {
                        GlobalFunFty.msg('请输入反馈内容');
                        return;
                    }
                    GlobalFunFty.getPostInfos({
                        url: FeedBackFty.feedApi,
                        data: $scope.params
                    })
                        .then(function (data) {
                            GlobalFunFty.msg('反馈成功，我们会尽快与您联系；谢谢您的意见');
                            $state.go('tab.account');
                        }, function (err) {
                            GlobalFunFty.info(err);
                        });

                };
            }]);

}(window.angular));