(function (angular) {
    "use strict";
    angular.module('login.service', ['global.service'])
        .factory('LoginFty', ['GlobalVariable', 'GlobalFunFty', '$state', '$stateParams', '$window','$rootScope',
            function (GlobalVariable, GlobalFunFty, $state, $stateParams, $window, $rootScope) {
                return {
                    getloginApi: GlobalVariable.SERVER_PATH + '/login/submit',      // 提交登录信息
                    getUserOccApi: GlobalVariable.SERVER_PATH + '/register/validateUsername', // 验证用户名是否被注册
                    getPhoneOccApi: GlobalVariable.SERVER_PATH + '/register/validatePhone', // 验证手机号是否被注册
                    getVerifCodeApi: GlobalVariable.SERVER_PATH + '/phone/sendPhoneVerifCode',  // 发送手机验证码
                    getRegisterApi: GlobalVariable.SERVER_PATH + '/register/submit',   // 注册
                    getForgotPassword: GlobalVariable.SERVER_PATH + '/account/ForgotPassword',  // 找回密码接口
                    clearAllLocal: function () {
                        GlobalFunFty.clearLocal('address',
                            'gender',
                            'phone',
                            'qq',
                            'signature',
                            'status',
                            'username', 'uuid', 'wechat', 'password', 'keyWord0', 'keyWord1', 'keyWord2');
                    },
                    submit: function (obj, erre) {

                        if(!GlobalFunFty.isStorageWorking()){
                            GlobalFunFty.msg('为优化您的浏览体验，请退出无痕模式,否则无法正常使用用登录功能', 3);
                            return;
                        }

                        GlobalFunFty.getPostInfos({
                            url: this.getloginApi,
                            data: obj
                        })
                            .then(function (data) {
                                var paramsData = data.data.data;
                                angular.forEach(paramsData, function (value, key) {
                                    GlobalFunFty.setLocal(key, value);
                                    if (key === 'uuid') {
                                        GlobalFunFty.setLocal('signature', $window.hex_md5(GlobalVariable.GLOBAL_STR + value));
                                    }
                                });

                                GlobalFunFty.setLocal('password', obj.password.trim());
                                if ($rootScope.currentPage) {
                                    $rootScope.currentPage.params.id;
                                    $state.go($rootScope.currentPage.name, $rootScope.currentPage.params)
                                    $rootScope.currentPage = null;
                                } else {
                                    $state.go('tab.home');
                                }

                            }, function (err) {
                                GlobalFunFty.msg(err);
                                erre();
                                return;
                            });
                    },
                    testUserName: function (name) {
                        return GlobalFunFty.getGetInfos({
                            url: this.getUserOccApi,
                            data: {username: name}
                        });
                    },
                    testPhone: function (phone) {
                        return GlobalFunFty.getGetInfos({
                            url: this.getPhoneOccApi,
                            data: {phone: phone}
                        });
                    },
                    sendCode: function (phone) {
                        return GlobalFunFty.getGetInfos({
                            url: this.getVerifCodeApi,
                            data: {phone: phone}
                        });
                    },
                    addUserInfo: function (obj) {
                        return GlobalFunFty.getPostInfos({
                            url: this.getRegisterApi,
                            data: obj
                        });
                    },
                    findPassWprd: function (obj) {
                        return GlobalFunFty.getPostInfos({
                            url: this.getForgotPassword,
                            data: obj
                        });
                    }
                };
            }]);

}(window.angular));