(function (angular) {
    "use strict";
    angular.module('message.controller', ['message.service', 'global.service'])
        .controller('MessageCtrl', ['$scope', '$state', 'MessageFty', 'GlobalFunFty',
            function ($scope, $state, MessageFty, GlobalFunFty) {

                GlobalFunFty.wxNoShare();

                $scope.pageInfo = MessageFty.pageInfo();// 初始化页面数据

                $scope.lineLeft = {
                    left: 0 + 'px'
                };
                $scope.current = [];
                $scope.isshow = true;
                $scope.scrollTo = 0;
                $scope.text = "正在加载...";
                $scope.allData = GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), {// 页面主参数
                    status: '',
                    pageSize: 999999,
                    offset: 0,
                });
                // 数据渲染
// 记录数据
                $scope.$on('$stateChangeStart', function (event,toState,toParams,fromState,fromParams) {
                    GlobalFunFty.setSession('message'+$scope.pageInfo.title, JSON.stringify({
                        params: $scope.allData,
                        data: $scope.current,
                        scrollTo: $scope.scrollTo,
                        lineLeft: $scope.lineLeft
                    }))

                })
                $scope.rememberScrollTop = function (top) {
                    $scope.scrollTo = top;
                }
                $scope.repeatFinish = function () {
                    $scope.toScrollTop($scope.scrollTo);
                }

                // 默认渲染总数据
                $scope.changeCurrent = function (val, $event, fn) {
                    var data = GlobalFunFty.getSession('message'+$scope.pageInfo.title);
                    if(data){
                        data = JSON.parse(data);
                        $scope.allData = data.params;
                        $scope.current = data.data;
                        $scope.scrollTo = data.scrollTo;
                        $scope.lineLeft = data.lineLeft;
                        GlobalFunFty.clearSession('message'+$scope.pageInfo.title)
                        return;
                    }


                    $scope.allData.offset = 0;
                    $scope.allData.status = val;
                    $scope.isshow = true;
                    $scope.scrollTo = 0;
                    $scope.text = "正在加载...";
                    $scope.current = [];
                    if ($event) {
                        $scope.lineLeft = {
                            left: $event.target.offsetLeft + 'px'
                        };
                    }
                    MessageFty.getMsageInfo($scope.allData)
                        .then(function (data) {
                            $scope.current = data.data.data;
                            $scope.isshow = false;
                            $scope.text = "已经加载完全部数据";
                        }, function (err) {
                            GlobalFunFty.info(err);
                        })
                        .finally(function () {
                            fn && fn();
                        });
                };
                $scope.deleteOrder = function (obj, index) {
                    GlobalFunFty.showDelMessage(function (fn) {

                        MessageFty.delMsageInfo(obj)
                            .then(function (data) {
                                GlobalFunFty.info(data);
                                $scope.current.splice(index, 1)
                                fn && fn();
                            }, function (err) {
                                GlobalFunFty.info(err);
                            })

                    })


                }
                // 默认渲染
                $scope.changeCurrent('', null, null);

                // 下拉刷新方法
                $scope.func_refreshGoodsList = function (flag) {
                    $scope.showEnd = true;
                    $scope.allData.offset = 0;
                    $scope.changeCurrent($scope.allData.status, null, function () {
                        $scope.$broadcast('scroll.refreshComplete');
                    });
                };

                // 加载更多方法
                $scope.func_loadMoreGoodsList = function () {
                    $scope.allData.offset += 1;
                    MessageFty.getMsageInfo($scope.allData)
                        .then(function (data) {
                            if (data.data.data.length === 10) {
                                $scope.showEnd = true;
                            } else {
                                $scope.showEnd = false;
                            }
                            $scope.current = $scope.current.concat(data.data.data);
                        }, function (err) {
                            GlobalFunFty.info(err);
                        })
                        .finally(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        });
                };


                $scope.publishNewSomething = function () {
                    $state.go('releaseStockMessage', {
                        way: $scope.pageInfo.goto
                    });
                };
            }
        ]);

}(window.angular));