(function (angular) {
   "use strict";
    // 引导页功能数据请求模块
    angular.module('message.service', ['global.service'])
        .factory('MessageFty', ['GlobalVariable', '$stateParams', 'GlobalFunFty', function (GlobalVariable, $stateParams, GlobalFunFty) {
            return {
                getPurchaseApi: GlobalVariable.SERVER_PATH + '/myhome/purchaseInfo/getMyPurchaseInfos',   //获取采购消息
                delPurchaseApi: GlobalVariable.SERVER_PATH + '/myhome/purchaseInfo/deletePurchaseInfo',  //删除采购消息
                getProvideApi: GlobalVariable.SERVER_PATH + '/myhome/provide/getMyProvideInfos',        //删除供应消息
                delProvideApi: GlobalVariable.SERVER_PATH + '/myhome/provide/deleteProvideInfo',
                pageInfo: function () {
                    var obj = {};
                    if ($stateParams.where === 'supply') {
                        obj = {
                            title: '供应',
                            get: this.getProvideApi,
                            del: this.delProvideApi,
                            goto: 'sellSomething',
                            where: 'supply',
                        };

                    } else if ($stateParams.where === 'purchase') {
                        obj =  {
                            title: '采购',
                            get: this.getPurchaseApi,
                            del: this.delPurchaseApi,
                            goto: 'buySomething',
                            where: 'purchase',
                        };
                    }
                    return obj;
                },
                getMsageInfo: function (obj) {
                    return GlobalFunFty.getGetInfos({
                        url: this.pageInfo().get,
                        data: obj
                    });
                },
                delMsageInfo: function (obj) {
                    return GlobalFunFty.getPostInfos({
                        url: this.pageInfo().del,
                        data: GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), {
                            id: obj.id
                        })
                    })
                }
            };
        }]);

}(window.angular));