(function (angular) {
    "use strict";
    angular.module('order.controller', ['order.service', 'global.service'])
        .controller('OrderCtrl', ['$scope', 'GlobalVariable', 'GlobalFunFty', 'OrderFty',
            function ($scope, GlobalVariable, GlobalFunFty, OrderFty) {
                GlobalFunFty.wxNoShare();
                $scope.title = OrderFty.getPageInfo().title;
                $scope.where = OrderFty.getPageInfo().where;
                $scope.lineLeft = {
                    left: 0 + 'px'
                };
                $scope.current = [];
                $scope.isshow = true;
                $scope.scrollTo = 0;
                $scope.text = "正在加载...";
                $scope.allData = GlobalFunFty.paramsCopy(GlobalFunFty.getUserInfo(), {
                    status: '',
                    pageSize: 999999,
                    offset: 0,
                });
                // 数据渲染
// 记录数据
                $scope.$on('$stateChangeStart', function (event,toState,toParams,fromState,fromParams) {
                    GlobalFunFty.setSession('order'+$scope.title, JSON.stringify({
                        params: $scope.allData,
                        data: $scope.current,
                        scrollTo: $scope.scrollTo,
                        lineLeft: $scope.lineLeft
                    }))

                })
                $scope.rememberScrollTop = function (top) {
                    $scope.scrollTo = top;
                }
                $scope.repeatFinish = function () {
                    $scope.toScrollTop($scope.scrollTo);
                }

                // 默认渲染总数据
                $scope.changeCurrent = function (val, $event, fn) {
                    var data = GlobalFunFty.getSession('order'+$scope.title);
                    if(data){
                        data = JSON.parse(data);
                        $scope.allData = data.params;
                        $scope.current = data.data;
                        $scope.scrollTo = data.scrollTo;
                        $scope.lineLeft = data.lineLeft;
                        GlobalFunFty.clearSession('order'+$scope.title)
                        return;
                    }
                    $scope.allData.offset = 0;
                    $scope.allData.status = val;
                    $scope.isshow = true;
                    $scope.text = "正在加载...";
                    $scope.current = [];
                    $scope.scrollTo = 0
                    if ($event) {
                        $scope.lineLeft = {
                            left: $event.target.offsetLeft + 'px'
                        };
                    }
                    OrderFty.getInfo($scope.allData)
                        .then(function (data) {
                            $scope.current = data.data.data;
                            $scope.isshow = false;
                            $scope.text = "已经加载完全部数据";
                        }, function (err) {
                            GlobalFunFty.info(err);
                        })
                        .finally(function () {
                            if(fn){
                                fn();
                            }
                        });
                };
                // 默认渲染
                $scope.changeCurrent('', null, null);

                window.addEventListener('scroll', function (e) {
                    console.log(e);
                })

                // 下拉刷新方法
                $scope.func_refreshGoodsList = function (flag) {
                    $scope.showEnd = true;
                    $scope.allData.offset = 0;
                    $scope.changeCurrent($scope.allData.status, null, function () {
                        $scope.$broadcast('scroll.refreshComplete');
                    });
                };

                // 加载更多方法
                $scope.func_loadMoreGoodsList = function () {
                    $scope.allData.offset += 1;
                    OrderFty.getInfo($scope.allData)
                        .then(function (data) {
                            if (data.data.data.length) {
                                $scope.showEnd = true;
                            } else {
                                $scope.showEnd = false;
                            }
                            $scope.current = $scope.current.concat(data.data.data);
                        }, function (err) {
                            GlobalFunFty.info(err);
                        })
                        .finally(function () {
                            $scope.$broadcast('scroll.infiniteScrollComplete');
                        });
                };
            }
        ]);

}(window.angular));