(function (angular) {
    "use strict";
    // 引导页功能数据请求模块
    angular.module('order.service', ['global'])
        .factory('OrderFty', ['GlobalVariable', 'GlobalFunFty', '$stateParams', function(GlobalVariable, GlobalFunFty, $stateParams) {
            return {
                getPurchaseApi: GlobalVariable.SERVER_PATH + '/order/get/myPurchaseOrder',   //获取采购订单
                getProvideApi: GlobalVariable.SERVER_PATH + '/order/get/myProvideOrder',        //删除供应订单
                getPageInfo: function () {
                    var obj = {};
                    if ($stateParams.where === 'provide') {
                        obj.title = '供应';
                        obj.get = 2;
                        obj.del = 3;
                        obj.goto = 'sellSomething';
                        obj.where = 'provide';

                    } else if ($stateParams.where === 'purchase') {
                        obj.title = '采购';
                        obj.get = 0;
                        obj.del = 1;
                        obj.goto = 'buySomething';
                        obj.where = 'purchase';
                    }
                    return obj;
                },
                getInfo: function (obj) {
                    var url;
                    switch (this.getPageInfo().get) {
                        case 0:
                            url = this.getPurchaseApi;
                            break;
                        case 2:
                            url = this.getProvideApi;
                            break;
                    }
                    return GlobalFunFty.getGetInfos({
                        url: url,
                        data: obj
                    });
                }
            };
        }]);

}(window.angular));