(function (angular) {
    "use strict";
    angular.module('orderDetails.service', ['global.service'])
        .factory('OrderDetailsFty', ['GlobalVariable', '$stateParams', 'GlobalFunFty',
            function (GlobalVariable, $stateParams, GlobalFunFty) {
                return {
                    getPurchaseOrderDetaukApi: GlobalVariable.SERVER_PATH + "/order/get/myPurchaseOrderDetail",
                    getProvideOrderDetaukApi: GlobalVariable.SERVER_PATH + "/order/get/myProvideOrderDetail",
                    getPageInfo: function () {
                        if ($stateParams.where === 'purchase') {
                            return {
                                title: '采购',
                                url: this.getPurchaseOrderDetaukApi,
                                purchase: true,
                                provide: false,
                            };
                        } else if ($stateParams.where === 'provide') {
                            return {
                                title: '供应',
                                url: this.getProvideOrderDetaukApi,
                                purchase: false,
                                provide: true,
                            };
                        }
                    },
                    getDetailInfo: function () {
                        var _this = this;
                        return GlobalFunFty.detLogin(true, function (obj) {
                            obj.orderNo = $stateParams.orderNo;
                            return GlobalFunFty.getGetInfos({
                                url: _this.getPageInfo().url,
                                data: obj
                            });
                        });
                    },
                    wechat: function () {
                        GlobalFunFty.wxNoShare();
                    }
                };
            }]);

}(window.angular));