(function (angular) {
    'use strict';
    angular.module('personalStore.service', ['global.service'])
        .factory('PersonalStoreFty', ['GlobalVariable', 'GlobalFunFty', '$stateParams','$state',
            function (GlobalVariable, GlobalFunFty, $stateParams, $state) {

                return {
                    getGoodsApi: GlobalVariable.SERVER_PATH + '/home/searchProvideInfos',            // 获取页面 list 数据
                    getShopApi: GlobalVariable.SERVER_PATH + '/shop/getUserShop',           // 获取用户店铺信息
                    delShopCollectApi: GlobalVariable.SERVER_PATH + '/myhome/collection/deleteShop',   // 删除收藏店铺
                    addShopCollectApi: GlobalVariable.SERVER_PATH + '/myhome/collection/shop',   // 添加收藏店铺
                    getShopId: function () {
                        if($stateParams.id){
                            return $stateParams.id;
                        }else {
                            GlobalFunFty.goError();
                            return null;
                        }


                    },
                    getShopInfo: function () {
                        if(!this.getShopId()){ return };
                        return GlobalFunFty.getGetInfos({
                            url: this.getShopApi,
                            data: {
                                uuid: this.getShopId(),
                                isZhaoNiuReport: true,
                                userId: GlobalFunFty.getUserInfo() ? GlobalFunFty.getUserInfo().uuid : '',
                            }
                        });
                    },
                    getGoods: function (obj) {
                        if(!this.getShopId()){ return };
                        var params = {
                            uuid: this.getShopId(),
                            offset: 0,
                            amountReverse: '',
                            priceReverse: '',
                            pageSize: GlobalVariable.SUPPLY_PAGESIZE,
                            updateDate: ''
                        };
                        return GlobalFunFty.getGetInfos({
                            url: this.getGoodsApi,
                            data: GlobalFunFty.paramsCopy(params, obj)
                        });
                    },
                    addCollect: function () {
                        if(!this.getShopId()){ return };
                        var _this = this;
                        return GlobalFunFty.detLogin(true, function (obj) {
                            return GlobalFunFty.getPostInfos({
                                url: _this.addShopCollectApi,
                                data: GlobalFunFty.paramsCopy(obj, {
                                    shopUserId: _this.getShopId()
                                })
                            });
                        });
                    },
                    delCollect: function () {
                        if(!this.getShopId()){ return };
                        var _this = this;
                        return GlobalFunFty.detLogin(true, function (obj) {
                            return GlobalFunFty.getPostInfos({
                                url: _this.delShopCollectApi,
                                data: GlobalFunFty.paramsCopy(obj, {
                                    'ids[]': _this.getShopId()
                                })
                            });
                        });
                    },
                    wechat: function (obj) {
                        if($state.current.name !== 'personalstore.info'){
                            obj.desc = "我在这家店中找到了一直找不到的货，快看看有没有你一直苦苦寻找的。";
                        }
                        GlobalFunFty.wxShare({
                            title: obj.title,
                            desc: obj.desc,
                            imgUrl: obj.imgUrl
                        });
                    }
                };
            }]);
})(window.angular);
