(function (angular, $) {
    "use strict";
    angular.module('purchase.controller', ['purchase.service', 'global.service'])
        .controller('PurchaseCtrl', ['$scope', 'GlobalVariable', 'PurchaseFty', 'GlobalFunFty', '$window', '$timeout', '$state',
            function ($scope, GlobalVariable, PurchaseFty, GlobalFunFty, $window, $timeout, $state) {
            GlobalFunFty.wxShare({
                title: "找牛网采购消息 你想卖的 买主在这"
            })
// 记录历史纪录

            $scope.$on('$stateChangeStart', function (event,toState,toParams,fromState,fromParams) {
                if(toState.name === "deliveryDetails"){
                    GlobalFunFty.setSession('purchase', JSON.stringify({
                        params: $scope.allParams,
                        offset: $scope.offset,
                        data: $scope.recommend,
                        scrollTo: $scope.scrollTo,
                        pms_isMoreItemsAvailable: $scope.pms_isMoreItemsAvailable
                    }))
                }
                return;
            })
// 初始化页面参数
                $scope.allParams = PurchaseFty.getAllParams();
                $scope.offset = GlobalVariable.OFFSET;
                $scope.isshow = true;
                // 商品列表数据对象
                $scope.recommend = [];
                // 判断有没有更多数据可以加载
                $scope.pms_isMoreItemsAvailable = true;
                $scope.text = "正在加载...";
                $scope.total = 10;
                $scope.scrollTo = 0;
                $scope.history = false;

                $scope.$watch('allParams', function (newVla, oldval) {

                    // 如果点击 tab 切换牛羊的话 则初始化页面所有数据
                    if(oldval.meatType !== newVla.meatType){
                        $scope.currentChoose = {updateDate: GlobalVariable.PURCHASE_UPDATA};
                        $scope.requestData();
                    }

                    var allStr = JSON.parse(GlobalFunFty.getSession('purchase'));
                    if(allStr){
                        $scope.recommend = allStr.data
                        $scope.allParams = allStr.params
                        $scope.scrollTo = allStr.scrollTo
                        $scope.offset = allStr.offset
                        $scope.pms_isMoreItemsAvailable = allStr.pms_isMoreItemsAvailable
                        if(!$scope.pms_isMoreItemsAvailable){
                            $scope.text = "已加载完全部数据";
                        }
                        $scope.history = true;
                        GlobalFunFty.clearSession('purchase')
                        return;
                    }
                    if($scope.history){     // 上一部给 allParams 赋值了 就会再次触发 history  就直接返回
                        $scope.history = false;
                        return;
                    }

                    $scope.refreshGoodsList();
                    $scope.jroll.scrollTo(0, 0, 0);
                }, true);
// ng-repeat 循环完成触发事件 jroll refresh 事件 由于 repeat 延迟问题 造成当前高度获取错误问题 使用延迟定时器解决
                $scope.repeatFinish = function () {
                    GlobalFunFty.JrollRefresh($scope.jroll, null, $scope.scrollTo);
                };

                // 这是 jroll 初始化完成事件  接受 scroll-content 事件
                $scope.$on('scroll-finish', function ($event, data) {
                    $event.stopPropagation();
                    $scope.jroll = data;

                    // 判断是否到底部  进行下一页加载
                    $scope.jroll.on("scrollEnd", function () {
                        if (this.y === this.maxScrollY && $scope.pms_isMoreItemsAvailable) {
                            $scope.loadMoreGoodsList();
                        }
                        $scope.scrollTo = this.y;
                    });

                    // 下拉刷新插件
                    $scope.jroll.pulldown({
                        iconArro: 'img/pull.png',
                        iconLoadin: 'img/pull_loading.gif',
                        iconFinis: 'img/pull_finish.png',
                        spinning: false,    // 使用的是自带的图片 禁止 icon 旋转；
                        refresh: function (complete) {
                            $scope.refreshGoodsList(function () {
                                complete();
                            });
                        }
                    });
                });
                // 下拉刷新方法
                $scope.refreshGoodsList = function (fn) {
                    $scope.recommend = [];  // 初始化所有数据
                    $scope.pms_isMoreItemsAvailable = true;
                    $scope.text = "正在加载...";
                    $scope.total = 10;

                    // 只要进入了这个方法 历史记录就删掉
                    GlobalFunFty.clearSession('purchase')
                    $scope.scrollTo = 0;
                    $scope.history = false;

                    if(fn){
                        $scope.isshow = false;
                    }
                    var message = angular.copy($scope.allParams);
                    message.offset = $scope.offset = 0;
                    // 获取数据
                    PurchaseFty.getProvideList(message)
                        .then(function (data) {
                            var pageData = data.data;
                            if(message.keyWord){
                                GlobalFunFty.wxShare({
                                    title: "你想卖的["+message.keyWord+"]，众多买家重金求购",
                                    link: encodeURI($window.location.host + $window.location.pathname +"?keyWord=" + message.keyWord + $window.location.hash)
                                })
                            };
                            $scope.isshow  = $scope.total = pageData.total;
                            if (pageData.total) {
                                $scope.recommend = pageData.data;
                                if (pageData.data.length < 10 || pageData.total <= 10) {
                                    $scope.pms_isMoreItemsAvailable = false;
                                    $scope.text = "已加载完全部数据";
                                } else {
                                    $scope.pms_isMoreItemsAvailable = true;
                                    $scope.text = "正在加载...";
                                }
                            } else {
                                $scope.recommend = [];
                                $scope.pms_isMoreItemsAvailable = false;
                                $scope.text = "暂无数据";
                            }
                        }, function (err) {
                            GlobalFunFty.info(err);
                        })
                        .finally(function () {
                            // 执行毁掉函数 并初始化 jroll 对象
                            if (fn) {
                                fn();
                            }
                            GlobalFunFty.JrollRefresh($scope.jroll);
                        });
                };

                // 加载更多方法
                $scope.loadMoreGoodsList = function () {

                    // // 加载更多的时候让页码加1
                    $scope.offset += 1;
                    var message = angular.copy($scope.allParams);
                    message.offset = $scope.offset;
                    // 获取数据
                    PurchaseFty.getProvideList(message)
                        .then(function (data) {
                            var PageData = data.data;
                            if (PageData.data.length < 10) {
                                $scope.pms_isMoreItemsAvailable = false;
                                $scope.text = "已加载完全部数据";
                            } else {
                                $scope.pms_isMoreItemsAvailable = true;
                                $scope.text = "正在加载...";
                            }
                            $scope.recommend = $scope.recommend.concat(PageData.data);
                        }, function (err) {
                            GlobalFunFty.info(err);
                        })
                        .finally(function () {
                            // 初始化 jroll 对象
                            GlobalFunFty.JrollRefresh($scope.jroll);
                        });
                };


                // 重置按钮
                $scope.reset = function () {
                    $scope.clearSieve();
                    $scope.allParams = {
                        meatType: $scope.allParams.meatType,
                        updateDate: GlobalVariable.PURCHASE_UPDATA,
                        country: '',
                        amountReverse: '',
                        priceReverse: '',
                        warehouse: '',
                        meatTypeDetails: '',
                        packingId: '',
                        keyWord: '',
                        pageSize: GlobalVariable.PAGESIZE,
                    };

                };

                // 筛选菜单
                $scope.sieveType = [{name: '产品类别', type: 'keyWord', model: $scope.allParams.meatTypeDetails},
                    {name: '产品产地', type: 'country', model: $scope.allParams.country},
                    {name: '供货地', type: 'warehouse', model: $scope.allParams.warehouse},
                    {name: '发布时间', type: 'updateDate', model: $scope.allParams.updateDate}];
                // 默认初始页面
                $scope.sieveCurrentIndex = -1;
                $scope.currentPlaceNum = -1;
                $scope.currentCountryNum = -1;
                $scope.currentMeatNum = -1;
                $scope.guonei = [];
                $scope.guowai = [];
                $scope.yangrouType = [];
                $scope.niurouType = [];
                $scope.shouLaBox = false;
                $scope.currentChoose = {updateDate: $scope.allParams.updateDate};

                // 筛选 供货地
                PurchaseFty.getAllGoodsLocusList()
                    .then(function (data) {
                        $scope.currentPlace = data.data.data;
                    })
                    .finally(function () {
                        $timeout(function () {
                            $('.searchItim', '.warehouse').accordion({
                                //accordion: true,
                                speed: 100,
                                closedSign: '[+]',
                                openedSign: '[-]'
                            });
                        }, 500)
                    });

                // 产地
                PurchaseFty.getCountryList()
                    .then(function (data) {
                        var countrydata = data.data.data;
                        countrydata.forEach(function (value, index) {
                            if (value.parentId === 1) {
                                $scope.guonei.push(value);
                            } else if (value.parentId === 2) {
                                $scope.guowai.push(value);
                            }
                        });
                    })
                    .finally(function () {
                        $timeout(function () {
                            $('.searchItim', '.country').accordion({
                                //accordion: true,
                                speed: 100,
                                closedSign: '[+]',
                                openedSign: '[-]'
                            });
                        }, 500)
                    });


                // 产品种类
                PurchaseFty.getAllMeatCategoryList()
                    .then(function (data) {
                        $scope.niurouType = data.data.data[0].childrenList;
                        $scope.yangrouType = data.data.data[1].childrenList;
                    })
                    .finally(function () {
                        $timeout(function () {
                            $('.metyType').accordion({
                                //accordion: true,
                                speed: 100,
                                closedSign: '[+]',
                                openedSign: '[-]'
                            });
                        }, 500)
                    });

                // 当前 显示项
                $scope.fun_changeSiveCurrentIndex = function (index) {
                    $scope.sieveCurrentIndex = index;
                };
                // 筛选 时间
                $scope.fun_changeUpDate = function (date) {
                    $scope.currentChoose.updateDate = date;
                    $scope.sieveCurrentIndex = -1;
                };
                // 产地 怪变
                $scope.changeCountry = function (city) {
                    $scope.currentChoose.country = city.countryName;
                    $scope.currentCountryNum = city.id;
                    $scope.sieveCurrentIndex = -1;
                };
                // 供货地 怪变
                $scope.changePlace = function (city) {
                    $scope.currentChoose.warehouse = city.goodsLocusName;
                    $scope.currentPlaceNum = city.id;
                    $scope.sieveCurrentIndex = -1;
                };
                // 产品种类 怪变
                $scope.changeMeatType = function (city) {
                    $scope.currentChoose.keyWord = city.meatName;
                    $scope.currentMeatNum = city.id;
                    $scope.sieveCurrentIndex = -1;
                };
                // 供应筛选 收拉盒子
                $scope.toggleSieve = function () {
                    $scope.shouLaBox = !$scope.shouLaBox;
                };
                // 匹配模糊关键词
                $scope.currentMet = '';
                $scope.keyWordArray = [];
                $scope.changeInputMetyType = function () {
                    if (!($scope.currentMet.trim())) {
                        $scope.keyWordArray = [];
                        return;
                    }
                    PurchaseFty.getMeatCategoryList($scope.currentMet)
                        .then(function (data) {
                            $scope.keyWordArray = data.data.data.splice(0, 10);
                        });
                };
                $scope.clearKeyWordArray = function () {
                    $scope.keyWordArray = [];
                    $scope.currentMet = '';
                };
                $scope.chooseKeyWorld = function (obj) {
                    $scope.sieveCurrentIndex = -1;
                    $scope.currentChoose.keyWord = obj.meatName
                    $scope.currentMet = obj.meatName;
                    $scope.keyWordArray = [];
                    $scope.currentMeatNum = obj.id;
                };
                $scope.clearSieve = function () {
                    $scope.sieveCurrentIndex = -1;
                    $scope.currentPlaceNum = -1;
                    $scope.currentCountryNum = -1;
                    $scope.currentMeatNum = -1;
                    $scope.currentChoose = {updateDate: GlobalVariable.PURCHASE_UPDATA};
                };
                $scope.requestData = function () {
                    $scope.shouLaBox = false;
                    $scope.allParams = {
                        meatType: $scope.allParams.meatType,
                        // upDate
                        updateDate: $scope.currentChoose.updateDate || '',
                        country: $scope.currentChoose.country || '',
                        amountReverse: $scope.allParams.amountReverse,
                        priceReverse: $scope.allParams.priceReverse,
                        warehouse: $scope.currentChoose.warehouse || '',
                        meatTypeDetails: $scope.allParams.meatTypeDetails,
                        packingId: $scope.allParams.packingId,
                        keyWord: $scope.currentChoose.keyWord || '',
                        pageSize: $scope.allParams.pageSize,
                    };
                };
                $scope.showSearch = function () {
                    $state.go('tab.purchase.search', {
                        search:true
                    })
                }

            }
        ]);

}(window.angular, window.$));
