(function (angular) {
    "use strict";
    // 引导页功能数据请求模块
    angular.module('purchase.service', ['global.service'])
        .factory('PurchaseFty', ['GlobalVariable', '$stateParams', 'GlobalFunFty', '$window',
            function (GlobalVariable, $stateParams, GlobalFunFty, $window) {
                return {
                    getAllMeatCategoryApi: GlobalVariable.SERVER_PATH + '/category/searchAllMeatCategory',  // 获取产品类别
                    getCountryApi: GlobalVariable.SERVER_PATH + '/country/getCountryInfos',                 // 获取产地
                    getAllGoodsLocusApi: GlobalVariable.SERVER_PATH + '/goodsLocus/searchAllGoodsLocus',    // 获取所在地
                    getMeatCategoryApi: GlobalVariable.SERVER_PATH + '/category/getMeatCategoryInfos',    // 关键词模糊匹配
                    getProvideApi: GlobalVariable.SERVER_PATH + '/home/searchPurchaseInfos',            // 获取页面 list 数据
                    getAllParams: function () {
                        return {
                            meatType: $window.Number($stateParams.meatType || GlobalFunFty.getQueryString('meatType') || 0),
                            updateDate: GlobalVariable.PURCHASE_UPDATA,
                            country: '',
                            amountReverse: '',
                            priceReverse: '',
                            warehouse: '',
                            meatTypeDetails: '',
                            packingId: '',
                            keyWord: $stateParams.keyWord || GlobalFunFty.getQueryString('keyWord') || '',
                            pageSize: GlobalVariable.PAGESIZE,
                        };
                    },
                    getProvideList: function (obj) {
                        return GlobalFunFty.getGetInfos({
                            url: this.getProvideApi,
                            data: obj,
                        });
                    },
                    getAllGoodsLocusList: function () {
                        return GlobalFunFty.getGetInfos({
                            url: this.getAllGoodsLocusApi
                        });
                    },
                    getCountryList: function () {
                        return GlobalFunFty.getGetInfos({
                            url: this.getCountryApi
                        });
                    },
                    getAllMeatCategoryList: function () {
                        return GlobalFunFty.getGetInfos({
                            url: this.getAllMeatCategoryApi
                        });
                    },
                    getMeatCategoryList: function (keyWord) {
                        return GlobalFunFty.getGetInfos({
                            url: this.getMeatCategoryApi,
                            data: {keyWord: keyWord}
                        });
                    },

                };
            }
        ]);

}(window.angular));