(function (angular, $) {
    "use strict";
    angular.module('releaseStockMessage.controller', ['releaseStockMessage.service', 'global.service'])
        .controller('ReleaseStockMessageCtrl', ['$scope', '$window', '$state', '$stateParams', 'GlobalFunFty',
            'ReleaseStockMessageFty', '$timeout',
            function ($scope, $window, $state, $stateParams, GlobalFunFty, ReleaseStockMessageFty, $timeout) {

                GlobalFunFty.wxNoShare();
                GlobalFunFty.detLogin(true);
                // 判断当前页面
                $scope.pageInfo = ReleaseStockMessageFty.getPageInfo();

                $scope.allparams = {
                    meatType: '0',       // 产品种类
                    provideDesc: '',    // 产品详情
                    meatCategoryId: '', //产品类别
                    packingId: '',   // 包装规格
                    factoryNo: '',   // 厂牌常昊
                    warehouse: '',   // 所在地
                    amount: '',         // 产品数量
                    shelfLife: '请选择产品保质期',   // 保质期
                    invalidDate: '请选择消息失效期',   // 失效日期
                    contact: GlobalFunFty.getLocal('username') || '',   // 发布人姓名
                    phone: Number(GlobalFunFty.getLocal('phone')) || '',   // 发布人电话
                    qq: Number(GlobalFunFty.getLocal('qq')) || '',   // 发布人QQ
                    weChat: Number(GlobalFunFty.getLocal('weChat')) || '',   // 发布人微信
                    provideWayId: '0',   // 供应类型
                    scale: '',   // 静修比例
                    countryId: '',   // 产地
                    imageUrl: '',       // 图片 用 ，隔开
                    unit: '',   // 肉的单位
                    price: '',   // 肉的单价
                    company: '',   // 企业名称
                    uuid: GlobalFunFty.getLocal('uuid') || '',
                    signature: GlobalFunFty.getLocal('signature') || '',
                };
                $scope.hide = false;

                // 日期插件
                $timeout(function () {
                    (function () {
                        $window.laydate({
                            elem: '#date1',
                            min: $window.laydate.now(),
                            choose: function (dates) {
                                $scope.allparams.shelfLife = dates;
                            },
                            istoday: false,
                        });//绑定元素
                        $window.laydate({
                            elem: '#date2',
                            min: $window.laydate.now(),
                            max: $window.laydate.now(+$scope.pageInfo.time),
                            choose: function (dates) {
                                $scope.allparams.invalidDate = dates;
                            },
                            istoday: false,
                        });//绑定元素
                    }());
                }, 500)

                // 肉的类别
                ReleaseStockMessageFty.getMeatCategory()
                    .then(function (data) {
                        $scope.niuId = data.data.data[0].childrenList;
                        $scope.yangId = data.data.data[1].childrenList;
                    }, function (err) {
                        GlobalFunFty.info(err);
                    });

                // 产品产地
                ReleaseStockMessageFty.getProvidePlace()
                    .then(function (data) {
                        var placeData = data.data.data,
                            datalist = [placeData[0], placeData[1]];
                        datalist[0].childrenlist = [];
                        datalist[1].childrenlist = [];
                        placeData.forEach(function (value, index) {
                            if (value.parentId === 1) {
                                datalist[0].childrenlist.push(value);
                            } else if (value.parentId === 2) {
                                datalist[1].childrenlist.push(value);
                            }
                        });
                        $scope.countryList = datalist;
                    }, function (err) {
                        GlobalFunFty.info(err);
                    });
                // 所在地
                ReleaseStockMessageFty.getAllPlace()
                    .then(function (data) {
                        $scope.currentPlace = data.data.data;
                    }, function (err) {
                        GlobalFunFty.info(err);
                    });


                $scope.mySelef = {
                    // image 大小
                    imgheight: {
                        'height': $window.innerWidth / 100 * 94 / 100 * 30 + 'px'
                    },
                    imageList: [],   // 上传的image
                    changeInput: false,     // 是否点击了图片上传
                    removeImgList: function (event, index) {   // 图片删除按钮点击
                        this.changeInput = true;
                        GlobalFunFty.showDelImage(event, index, function (Ele, index) {
                            $scope.mySelef.imageList.splice(index, 1);
                            $scope.$broadcast('delete-image', $scope.mySelef.imageList);
                            $scope.$apply();
                        });
                    },
                    uploadImage: function (fn) {      // 上传图片
                        var imgStr = '';
                        if (this.changeInput) {
                            var len = this.imageList.length;
                            if (len) {
                                GlobalFunFty.showImgUpload(function () {
                                    var count = 0;
                                    $scope.mySelef.imageList.forEach(function (value, index) {
                                        GlobalFunFty.upLoadImage(value.formData)
                                            .then(function (data) {
                                                imgStr += data.data.message + ',';
                                                if (count === len - 1) {
                                                    GlobalFunFty.closeAll();
                                                    fn(imgStr);
                                                }
                                                count++;
                                            }, function (err) {
                                                GlobalFunFty.info(err);
                                            });
                                    });
                                });


                            } else {
                                fn(imgStr);
                            }
                        } else {
                            fn(imgStr);
                        }

                    },
                    // 产品类别手风琴效果
                    finish: function () {
                        $('.searchItim', '.leibie-box').accordion({       //// 手风琴效果
                            // accordion: true,
                            speed: 100,
                            closedSign: '[+]',
                            openedSign: '[-]'
                        });
                    },
                    // 显示产品类别
                    showMeatCategory: function () {
                        $scope.hide = this.meatCategory = true;
                    },
                    meatCategory: false,    // 产品类别莫太坑开关
                    meatCategoryId: '-1',    // 产品类别选项
                    selectMeatCategoryId: function (obj) {      // 选择产品类别
                        this.meatCategoryId = obj.id;
                        $scope.allparams.meatCategoryId = obj.id;
                        $scope.hide = this.meatCategory = false;
                        $scope.meatCategory = obj.meatName;
                    },
                    clearM: function () {
                        this.meatCategoryId = '-1';
                        $scope.allparams.meatCategoryId = '';
                        $scope.meatCategory = '';
                        $scope.hide = this.meatCategory = false;
                        $scope.currentMet = '';
                        $scope.keyWordArray = [];

                    },
                    //-------------------------------------------------------------
                    // 产地相关
                    countryFinish: function () {
                        setTimeout(function () {
                            $('.searchItim', '.item-country').accordion({       //// 手风琴效果
                                // accordion: true,
                                speed: 100,
                                closedSign: '[+]',
                                openedSign: '[-]'
                            });
                        }, 500);
                    },
                    currentCountryNum: '-1',
                    countryModelShow: true,
                    changeCountry: function (city) {
                        this.currentCountryNum = city.id;
                        $scope.allparams.countryId = city.id;
                        this.countryModelShow = true;
                        $scope.hide = false;
                        $scope.country = city.countryName;
                    },
                    // --------------------------------------------------------------
                    // 所在地 相关
                    warehouseFinish: function () {
                        setTimeout(function () {
                            $('.searchItim', '.item-warehouse').accordion({       //// 手风琴效果
                                // accordion: true,
                                speed: 100,
                                closedSign: '[+]',
                                openedSign: '[-]'
                            });
                        }, 500);

                    },
                    currentPlaceNum: '-1',
                    PlaceModelShow: true,    // 莫泰狂开关
                    changePlace: function (city) {  // 选择事件
                        $scope.warehouse = city.goodsLocusName;
                        $scope.allparams.warehouse = city.goodsLocusName == '不限'?"": city.goodsLocusName;
                        this.currentPlaceNum = city.id;
                        this.PlaceModelShow = true;
                        $scope.hide = false;
                    },
                    showDate: function (even) {     // 日期选择插件
                        $('#dateBox').show(0, function () {
                            $(this).find('#laydate_box').show();
                        });
                        $timeout(function () {
                            $('.laydate_table').off('click').on('click', 'td.laydate_void', function () {
                                GlobalFunFty.msg("有效时间最多为"+ $scope.pageInfo.time +"天")
                            })
                        }, 500)

                    }
                };

                // 取消发布
                $scope.cancel = function () {
                    $window.history.back();
                };
                // 发布
                $scope.publish = function () {
                    if (!$scope.allparams.provideDesc) {
                        GlobalFunFty.closeAll();
                        GlobalFunFty.msg('产品详情不能为空');
                        return;
                    } else if(($('input[name="meatNumInput"]').val().length >= 10) ||($('input[name="meatPriceInput"]').val().length >= 10)){
                        GlobalFunFty.closeAll();
                        GlobalFunFty.msg("价格或数量异常，请重新输入");
                        return;
                    } else {
                        $scope.mySelef.uploadImage(function (str) {
                            var parData;
                            $scope.allparams.imageUrl = str || '';
                            $scope.allparams.countryId = $scope.allparams.countryId? $scope.allparams.countryId : '';
                            $scope.allparams.meatCategoryId = $scope.allparams.meatCategoryId? $scope.allparams.meatCategoryId : '';
                            $scope.allparams.warehouse = $scope.allparams.warehouse? $scope.allparams.warehouse : '';
                            $scope.allparams.invalidDate = $scope.allparams.invalidDate === '请选择消息失效期' ? '' : $scope.allparams.invalidDate;
                            $scope.allparams.shelfLife = $scope.allparams.shelfLife === '请选择产品保质期' ? '' : $scope.allparams.shelfLife;
                            if ($stateParams.way === 'buySomething') {
                                parData = {
                                    meatType: $scope.allparams.meatType || '',
                                    purchaseDesc: $scope.allparams.provideDesc || '',
                                    price: $scope.allparams.price || $('input[name="meatPriceInput"]').val() || '',
                                    meatCategoryId: $scope.allparams.meatCategoryId || '',
                                    deliveryArea: $scope.allparams.warehouse || '',
                                    amount: $scope.allparams.amount || $('input[name="meatNumInput"]').val() || '',
                                    shelfLife: $scope.allparams.shelfLife || '',
                                    invalidDate: $scope.allparams.invalidDate || '',
                                    contact: $scope.allparams.contact || '',
                                    qq: $scope.allparams.qq || '',
                                    phone: $scope.allparams.phone || '',
                                    weChat: $scope.allparams.weChat || '',
                                    countryId: $scope.allparams.countryId || '',
                                    uuid: $scope.allparams.uuid || '',
                                    signature: $scope.allparams.signature || '',
                                };
                            } else {
                                parData = angular.copy($scope.allparams);
                                angular.forEach(parData, function (val, key) {
                                    if(!val) parData[key] = '';
                                    if(key === 'amount' && !val) parData[key] = $('input[name="meatNumInput"]').val() || ''
                                    if(key === 'price' && !val) parData[key] = $('input[name="meatPriceInput"]').val() || ''
                                })
                            }
                            GlobalFunFty.info(parData)
                            ReleaseStockMessageFty.publish(parData)
                                .then(function (data) {
                                    GlobalFunFty.info(parData)
                                    $state.go('message', {
                                        where: $scope.pageInfo.togo
                                    });
                                }, function (err) {
                                    GlobalFunFty.msg(err)
                                });
                        });
                    }
                };
                // 接受指令传过来的 image
                $scope.$on('to-imagelist', function ($event, data) {
                    $event.stopPropagation();
                    $scope.mySelef.changeInput = data.changeInput;
                    $scope.mySelef.imageList = data.imgList;
                    $scope.$apply();
                });

                // 匹配模糊关键词
                $scope.clearKeyWordArray = function () {
                    $scope.keyWordArray = [];
                    $scope.currentMet = '';
                };

                $scope.chooseKeyWorld = function (obj) {
                    $scope.meatCategory = obj.meatName;
                    $scope.currentMet = obj.meatName;
                    $scope.keyWordArray = [];
                    $scope.hide = $scope.mySelef.meatCategory = false;
                    $scope.mySelef.meatCategoryId = obj.id;
                    $scope.allparams.meatCategoryId = obj.id;
                };

                $scope.currentMet = '';
                $scope.keyWordArray = [];
                $scope.changeInputMetyType = function () {
                    if (!($scope.currentMet.trim())) {
                        $scope.keyWordArray = [];
                        return;
                    }
                    ReleaseStockMessageFty.getMeatKeyWord($scope.currentMet)
                        .then(function (data) {
                            $scope.keyWordArray = data.data.data.splice(0, 10);
                        });
                };

                // 数量，价格异常提示
                $scope.tips = function (a, b) {
                    if(a !== undefined) return;
                    GlobalFunFty.closeAll();
                    GlobalFunFty.msg(b + "异常");
                }
                // 页面收缩与展开
                $scope.flexible = {
                    msg: false,
                    details: true,
                    imgList: true,
                    option: true,
                }

            }
        ]);

}(window.angular, window.$));