(function (angular) {
    "use strict";
    // 引导页功能数据请求模块
    angular.module('releaseStockMessage.service', ['global'])
        .factory('ReleaseStockMessageFty', ['GlobalVariable', '$stateParams', 'GlobalFunFty',
            function(GlobalVariable, $stateParams, GlobalFunFty) {
                return {
                    providePlaceApi: GlobalVariable.SERVER_PATH + "/country/getCountryInfos",       // 获取产品产地
                    categoryApi: GlobalVariable.SERVER_PATH + '/ category/getMeatCategoryInfos', // 模糊搜索所
                    meatCategoryApi: GlobalVariable.SERVER_PATH + '/category/searchAllMeatCategory',// 获取产品的种类
                    urlProvideApi: GlobalVariable.SERVER_PATH + '/myhome/provide/addProvideInfo',   // 发布供货信息
                    allPlaceApi: GlobalVariable.SERVER_PATH + '/goodsLocus/searchAllGoodsLocus', // 所在地
                    uploadImgApi: GlobalVariable.UPLOAD_IMAGE,                                      // 上传图片
                    urlPurchaseApi: GlobalVariable.SERVER_PATH + '/myhome/purchaseInfo/addPurchaseInfo',   // 发布采购信息
                    getPageInfo: function () {
                        var obj = {};
                        if ($stateParams.way === 'buySomething') {
                            obj.title = '采购';
                            obj.time = 7;
                            obj.publishBuy = this.urlPurchaseApi;
                            obj.togo = 'purchase';
                            obj.showThis = false;
                            obj.placeName = '交货地';
                        }else if ($stateParams.way === 'sellSomething'){
                            obj.title = '供应';
                            obj.time = 30;
                            obj.publishBuy = this.urlProvideApi;
                            obj.togo = 'supply';
                            obj.showThis = true;
                            obj.placeName = '所在地';
                        }
                        return obj;
                    },
                    getMeatCategory: function () {
                        return  GlobalFunFty.getGetInfos({
                            url: this.meatCategoryApi
                        });
                    },
                    getProvidePlace: function () {
                        return  GlobalFunFty.getGetInfos({
                            url: this.providePlaceApi
                        });
                    },
                    getAllPlace: function () {
                        return  GlobalFunFty.getGetInfos({
                            url: this.allPlaceApi
                        });
                    },
                    publish: function (obj) {
                        return GlobalFunFty.getPostInfos({
                            url: this.getPageInfo().publishBuy,
                            data: obj
                        });
                    },
                    getMeatKeyWord: function (key) {
                        return GlobalFunFty.getGetInfos({
                            url: this.categoryApi,
                            data: {keyWord:key}
                        });
                    }
                };
            }
        ]);

}(window.angular));