(function (angular, $) {
    "use strict";
    angular.module('supermarket.controller', ['supermarket.service', 'global.service'])
        .controller('SupermarketCtrl', ['$scope', 'SupermarketFty', 'GlobalFunFty', '$window','$stateParams', '$state', 'GlobalVariable',
            function ($scope, SupermarketFty, GlobalFunFty, $window, $stateParams, $state, GlobalVariable) {

                GlobalFunFty.wxShare({
                    title: "找牛网商场，清真正关品类全，靠谱！"
                });
// 记住用户访问记录
                $scope.$on('$stateChangeStart', function (event,toState,toParams,fromState,fromParams) {
                    console.log(toState);
                    if(toState.name === 'deliveryDetails' || toState.name === 'personalstore'){
                        GlobalFunFty.setSession('supermarket', JSON.stringify({
                            getDataParams: $scope.getDataParams,
                            offset: $scope.offset,
                            something: $scope.something,
                            allData: $scope.allData,
                            scrollTo: $scope.scrollTo,
                            isMoreData: $scope.isMoreData
                        }))
                    }


                })

                // 初始化页面数据
                $scope.getDataParams = {
                    //businessType: '',     牛 或 羊 非必填   这里不要了
                    shopName: $stateParams.name || '',
                    provideNumReversal: '',
                    zhaoNiuReportReversal: '',      // 默认找牛热度排序
                    pageSize: 10
                };

                $scope.offset = 0;
                $scope.something = '';
                $scope.allData = null;
                $scope.isMoreData = true;
                $scope.text = "正在加载...";
                $scope.hide = false;  // 是否显示正在加载
                $scope.total = 10; // 默认有数据
                $scope.scrollTo = 0;

                $scope.repeatFinish = function () {
                    GlobalFunFty.JrollRefresh($scope.jroll, null, $scope.scrollTo);

                };// repeat 完成函数

                $scope.changeParams = function (something, page, fn) {

// 如果有记录 则直接返回页面数据为记录即可
                    var allStr = JSON.parse(GlobalFunFty.getSession('supermarket'));
                    if(allStr){
                        $scope.getDataParams = allStr.getDataParams
                        $scope.offset = allStr.offset
                        $scope.something = allStr.something
                        $scope.allData = allStr.allData
                        $scope.scrollTo = allStr.scrollTo
                        $scope.isMoreData = allStr.isMoreData
                        if(!$scope.isMoreData) {
                            $scope.text = "已加载完全部数据";
                        }
                        GlobalFunFty.clearSession('supermarket')
                        return;
                    }

                    if (!$scope.isMoreData) {return;}  // 如果等于 false 说明已经没有数据了 不需要请求了

                    $scope.offset = page || 0;

                    $scope.something = something || '';

                    if ($scope.offset === 0) {

                        $scope.allData = [];

                        if (!$scope.hide) {   // 如果为 true 则说明正在执行下拉动作 无需 scrollTo 到顶部

                            $scope.$watch('jroll', function () {// 检测 如果有 jroll 属性 则滚动到

                                $scope.jroll.scrollTo(0, 0, 0);

                            });

                        }

                    }

                    // 只要进入了这个方法 历史记录就删掉
                    GlobalFunFty.clearSession('supply')
                    $scope.scrollTo = 0;
                    $scope.history = false;

                    SupermarketFty.getAllShop($scope.getDataParams, $scope.something, $scope.offset)

                        .then(function (data) {

                            // 后台最多返回 4件商品 但我们最多需要三件 直接处理数据 减少 Dom 压力
                            angular.forEach(data.data.data, function (val, index) {
                                if(val.provideInfos.length === 4){
                                    val.provideInfos.length = 3;
                                }
                            });
                            $scope.total = data.data.total;
                            if (data.data.total <= ($scope.offset + 1) * 10) {    // 如果总数比总显示条数少 则加载完了全部数据
                                $scope.isMoreData = false;
                                $scope.text = "已加载完全部数据";
                            }
                            if(fn){
                                fn(data.data);
                            }
                            if(!($scope.total = data.data.total)){
                                $scope.hide = true;
                            }

                        }, function (err) {
                            GlobalFunFty.info(err);
                        })

                        .finally(function () {

                            GlobalFunFty.JrollRefresh($scope.jroll);

                        });

                };// 请求数据函数

                $scope.default = function (something) {

                    if ($scope.something === something) {return;}

                    $scope.isMoreData = true;

                    $scope.changeParams(something, 0, function (data) {

                        $scope.allData = data.data;

                    });

                };//tab 栏点击

                $scope.default('zhaoNiuReportReversal');// 默认页面渲染

                $scope.$on('scroll-finish', function ($event, data) {

                    $event.stopPropagation();

                    $scope.jroll = data;

                    $scope.jroll.on("scrollEnd", function () {

                        if (this.y === this.maxScrollY && $scope.isMoreData) {

                            $scope.changeParams($scope.something, ++$scope.offset, function (data) {

                                $scope.allData = $scope.allData.concat(data.data);

                            });

                        }
                        $scope.scrollTo = this.y;

                    });// 加载更多

                    $scope.jroll.pulldown({
                        iconArro: 'img/pull.png',
                        iconLoadin: 'img/pull_loading.gif',
                        iconFinis: 'img/pull_finish.png',
                        spinning: false,    // 使用的是自带的图片 禁止 icon 旋转；
                        refresh: function (complete) {

                            $scope.hide = true;         // 重置数据

                            $scope.isMoreData = true;

                            $scope.text = "正在加载...";
                            $scope.title = 10;

                            $scope.changeParams($scope.something, 0, function (data) {

                                complete();

                                $scope.allData = data.data;

                                $scope.hide = false;
                            });

                        }
                    });// 下拉刷新插件

                    $scope.jroll.on("refresh", function () {

                        var imgListS = $('.imgList', '#supermarket-content');

                        imgListS.each(function (v, e) {
                            e.JrollV =  new $window.JRollViewer(e, {
                                data:'max',
                                success: function (me, index) {
                                    $state.go('supermarket.image', {
                                        number: index,
                                        imagebox: me
                                    })
                                }
                            });
                        });

                    });// 图片查看集

                });// jroll 初始化
                $scope.showSearch = function () {
                    GlobalFunFty.showSearch();
                }

                // 图片 OSS
                $scope.oss = {
                    icon: GlobalVariable.IMG_OSS_RULE().supermarket.shop_icon,
                    banner: GlobalVariable.IMG_OSS_RULE().supermarket.banner,
                    goods: GlobalVariable.IMG_OSS_RULE().supermarket.goods,
                    max_goods: GlobalVariable.IMG_OSS_RULE().supermarket.max_goods,
                }

            }
        ]);

}(window.angular, window.$));