(function (angular) {
    "use strict";
    angular.module('supermarket.route', ['supermarket.controller'])
        .config(['$stateProvider',function ($stateProvider) {

            $stateProvider
                .state('supermarket', {
                    url: '/supermarket',
                    params:{name:null},
                    templateUrl: 'models/supermarket/supermarket.html',
                    controller: 'SupermarketCtrl'
                })
                .state('supermarket.image', {
                    url: '/image/:number',
                    params: {
                        imagebox : null,
                        number: null
                    },
                    template:'<i class="hide"></i>',
                    controller: ['$scope', '$stateParams', '$window',function ($scope, $stateParams , $window) {
                        $scope.current = $stateParams.number;
                        $scope.imagebox = $stateParams.imagebox;
                        if(!$scope.imagebox){
                            $window.history.back();
                            return;
                        };
                        $scope.$on('$stateChangeStart', function () {
                            $scope.imagebox.hide();
                        })
                    }]
                })
                .state('supermarket.search', {
                        url: '/search',
                        params: {
                            search : null
                        },
                        templateUrl: 'models/components/search/search.html',
                        controller: 'SearchCtrl'
                    });

        }]);

}(window.angular));