(function (angular) {
  "use strict";
    // 引导页功能数据请求模块
    angular.module('supply.service', ['global.service'])
        .factory('SupplyFty', ['GlobalVariable', '$stateParams', 'GlobalFunFty', function (GlobalVariable, $stateParams, GlobalFunFty) {
            return {
                getAllMeatCategoryApi: GlobalVariable.SERVER_PATH + '/category/searchAllMeatCategory',  // 获取产品类别
                getCountryApi: GlobalVariable.SERVER_PATH + '/country/getCountryInfos',                 // 获取产地
                getAllGoodsLocusApi: GlobalVariable.SERVER_PATH + '/goodsLocus/searchAllGoodsLocus',    // 获取所在地
                getMeatCategoryApi: GlobalVariable.SERVER_PATH + '/category/getMeatCategoryInfos',    // 关键词模糊匹配
                getProvideApi: GlobalVariable.SERVER_PATH + '/home/searchProvideInfos',            // 获取页面 list 数据
                getAllParams: function () {
                    var obj = {
                        meatType: Number($stateParams.meatType || GlobalFunFty.getQueryString('meatType') || 0),
                        updateDate: GlobalVariable.SUPPLY_UPDATA,
                        provideWay: '',
                        country: '',
                        amountReverse: '',
                        priceReverse: '',
                        warehouse: '',
                        meatTypeDetails: '',
                        packingId: '',
                        factoryNo: '',
                        keyWord: $stateParams.keyWord || GlobalFunFty.getQueryString('keyWord') || '',
                        pageSize: GlobalVariable.PAGESIZE,
                    };
                    return obj;
                },
                getListData: function (obj) {
                    return GlobalFunFty.getGetInfos({
                        data: obj,
                        url: this.getProvideApi
                    });
                },
                getData: function (url) {
                    return GlobalFunFty.getGetInfos({
                        url: url
                    });
                },
                getMeatKeyWord: function (key) {
                    return GlobalFunFty.getGetInfos({
                        url: this.getMeatCategoryApi,
                        data: {keyWord:key}
                    });
                }

            };
        }]);

}(window.angular));